
;CodeVisionAVR C Compiler V3.12 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Debug
;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	RCALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _devices=R5
	.DEF _A=R6
	.DEF _A_msb=R7
	.DEF _B=R8
	.DEF _B_msb=R9
	.DEF _C=R10
	.DEF _C_msb=R11
	.DEF _D=R12
	.DEF _D_msb=R13
	.DEF _At=R4

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP _usart_rx_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _ana_comp_isr
	RJMP 0x00
	RJMP 0x00

_cmd_0:
	.DB  0x41,0x54,0x2B,0x49,0x50,0x52,0x3D,0x39
	.DB  0x36,0x30,0x30,0x0
_cmd_1:
	.DB  0x41,0x54,0x0
_cmd_2_0:
	.DB  0x41,0x54,0x2B,0x43,0x53,0x43,0x53,0x3D
	.DB  0x22,0x55,0x43,0x53,0x32,0x22,0x0
_cmd_2_1:
	.DB  0x41,0x54,0x2B,0x43,0x4D,0x47,0x46,0x3D
	.DB  0x30,0x0
_cmd_2_2:
	.DB  0x41,0x54,0x2B,0x43,0x4D,0x47,0x53,0x3D
	.DB  0x0
_cmd_3:
	.DB  0x30,0x30,0x30,0x31,0x30,0x30,0x30,0x42
	.DB  0x39,0x31,0x0
_cmd_4:
	.DB  0x41,0x54,0x48,0x30,0x0
_cmd_5:
	.DB  0xDF,0x20,0xE7,0xE0,0xEC,0xE5,0xF0,0xE7
	.DB  0x20,0x2D,0x20,0xD5,0xEE,0xEB,0xEE,0xE4
	.DB  0xED,0xEE,0x0
_cmd_6:
	.DB  0xD2,0xE5,0xEB,0xE5,0xF4,0xEE,0xED,0xED
	.DB  0xFB,0xE9,0x20,0xC7,0xE2,0xEE,0xED,0xEE
	.DB  0xEA,0x0
_cmd_7:
	.DB  0xC1,0xF0,0xE5,0xEB,0xEE,0xEA,0x20,0xC4
	.DB  0xE2,0xE5,0xF0,0xE8,0x0
_cmd_9:
	.DB  0x41,0x54,0x2B,0x43,0x4C,0x49,0x50,0x3D
	.DB  0x31,0x0
_cmd_10:
	.DB  0x41,0x54,0x44,0x2B,0x20,0x0
_cmd_11:
	.DB  0xD3,0xE4,0xE0,0xEB,0xE5,0xED,0x20,0xD2
	.DB  0xE5,0xEB,0xE5,0xF4,0xEE,0xED,0x20,0x0
_cmd_12:
	.DB  0xCD,0xEE,0xE2,0xFB,0xE9,0x20,0xCD,0xEE
	.DB  0xEC,0xE5,0xF0,0x20,0x0
_cmd_14:
	.DB  0x54,0x65,0x6D,0x20,0x0
_conv_delay_G100:
	.DB  0x64,0x0,0xC8,0x0,0x90,0x1,0x20,0x3
_bit_mask_G100:
	.DB  0xF8,0xFF,0xFC,0xFF,0xFE,0xFF,0xFF,0xFF

;GLOBAL REGISTER VARIABLES INITIALIZATION
__REG_VARS:
	.DB  0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0
	.DB  0x0

_0x3:
	.DB  0x30,0x37,0x39,0x31,0x30,0x33,0x30,0x39
	.DB  0x30,0x35,0x30,0x30

__GLOBAL_INI_TBL:
	.DW  0x09
	.DW  0x05
	.DW  __REG_VARS*2

	.DW  0x0C
	.DW  _cmd_8
	.DW  _0x3*2

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*******************************************************
;This program was created by the
;CodeWizardAVR V3.12 Advanced
;Automatic Program Generator
; Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : Auto Zapusk GSM
;Version :
;Date    : 16.02.2024
;Author  :  ..
;Company : Home
;Comments:      :   ,   ( 
;    5    2 )       
;4 1 (    -17 .)   4    PORT D4 ( 6)  GND  ...
;     DS18b20.
;  7 .
;
;
;Chip type               : ATmega8
;Program type            : Application
;AVR Core Clock frequency: 4,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*******************************************************/
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>                                      // 
;#include <ds18b20.h>                                    //     ds18b20
;
;
;// Declare your global variables here
;#define MAX_DS18B20 8
;float temp1;                                            //     
;unsigned char devices=0;                                //     DS18b20
;unsigned char rom_code[2][9];                           //     [4][9] 4 .
;unsigned int A,B,C,D=0;
;unsigned char At,Bt,Ct, Dt=0;
;//int Ct1 = 0;
;int znak = 0;                                           //    
;unsigned int Bt1 = 0;
;
;#define interval 50                                     //      Sim800L ( UART )
;#define ustavka 16
;#define _Tel_OFF 300
;#define RX_BUFFER_SIZE 150
;#define FRAMING_ERROR (1<<FE)
;#define PARITY_ERROR (1<<UPE)
;#define DATA_REGISTER_EMPTY (1<<UDRE)
;#define RX_COMPLETE (1<<RXC)
;#define _tim_end 60                                     //   ds18b20   
;#define _timer_perep 61628
;#asm
   .equ __w1_port=0x15 ;PORTC                           //   
   .equ __w1_bit=5
; 0000 0038 #endasm
;
;unsigned char i, rx_cursor;                             //  ()   
;char MyBuffer[RX_BUFFER_SIZE];                          //    SMS    
;unsigned int z;                                         //    
;flash unsigned char cmd_0[]={"AT+IPR=9600"};            //    UART
;flash unsigned char cmd_1[]={"AT"};                     //        ( 0)
;flash unsigned char cmd_2_0[]={"AT+CSCS=\"UCS2\""};     //  SMS "UCS2"  
;flash unsigned char cmd_2_1[]={"AT+CMGF=0"};            //  PUD  (  )
;flash unsigned char cmd_2_2[]={"AT+CMGS="};             // -    (   ) PUD SMS
;flash unsigned char cmd_3[]={"0001000B91"};             //  PUD SMS
;flash unsigned char cmd_4[]={"ATH0"};                   //   ( )
;flash unsigned char cmd_5[]={"  - "};     //    "."
;flash unsigned char cmd_6[]={" "};      //   "."
;flash unsigned char cmd_7[]={" "};           //   " "
;flash unsigned char cmd_9[]={"AT+CLIP=1"};              //     - 
;flash unsigned char cmd_10[]={"ATD+ "};                 //    "ATD+ +7xxxxxxxxxx;"
;flash unsigned char cmd_11[]={"  "};       //   " ."
;flash unsigned char cmd_12[]={"  "};          //   " "
;flash unsigned char cmd_14[]={"Tem "};                  //      "Tem -17"
;unsigned char cmd_8[]={"079103090500"};                 //  

	.DSEG
;int _flag = 0;                                          //   SMS  
;int Temperat = 0;                                       // .   .   
;int _Err = 0;                                           // -      5  ( 2)
;int _Err_out = 0;                                       //   -      (=1)
;int _Blokir = 0;                                        //     ( pfgecrjv ( ...
;int _Tel = 0;                                           //      (  )
;int Ring = 0;                                           //    = 4
;int Deact = 0;                                          //     -   "DEACT"  Deact==5  ...
;char _Tel_SMS = 0;                                      // :  0=  PUD SMS  1=    (15)
;int _tim = 0;                                           //    ds18b20
;unsigned char SMS_dlinna=0;
;unsigned char SMS_zag[28];
;unsigned char SMS_text[280];
;__eeprom unsigned char cmd_8e[];//={"+79123456789"};    //  
;__eeprom unsigned char _Tel_SMS_E = 0;                  // 0=  PUD SMS  1=    (15)
;//__eeprom unsigned char _u3E = 0;
;//=======================================================================
;// Timer1 overflow interrupt service routine
;interrupt [TIM1_OVF] void timer1_ovf_isr(void)
; 0000 0060 {

	.CSEG
_timer1_ovf_isr:
; .FSTART _timer1_ovf_isr
	RCALL SUBOPT_0x0
; 0000 0061 // Place your code here
; 0000 0062 _tim++;
	LDI  R26,LOW(__tim)
	LDI  R27,HIGH(__tim)
	RCALL SUBOPT_0x1
; 0000 0063 TCNT1 = _timer_perep;
	LDI  R30,LOW(61628)
	LDI  R31,HIGH(61628)
	OUT  0x2C+1,R31
	OUT  0x2C,R30
; 0000 0064 }
	RCALL SUBOPT_0x2
	RETI
; .FEND
;//------------------------------------------
;// USART Receiver interrupt service routine
;interrupt [USART_RXC] void usart_rx_isr(void)
; 0000 0068     {
_usart_rx_isr:
; .FSTART _usart_rx_isr
	RCALL SUBOPT_0x0
; 0000 0069     char status, data;
; 0000 006A     status=UCSRA;
	RCALL __SAVELOCR2
;	status -> R17
;	data -> R16
	IN   R17,11
; 0000 006B     data=UDR;
	IN   R16,12
; 0000 006C     if ((status & (FRAMING_ERROR | PARITY_ERROR )) ==0)
	MOV  R30,R17
	ANDI R30,LOW(0x14)
; 0000 006D       {
; 0000 006E 
; 0000 006F         }
; 0000 0070       if (Ring!=4)
	RCALL SUBOPT_0x3
	SBIW R26,4
	BREQ _0x5
; 0000 0071         {
; 0000 0072         if (data=='R') Ring=1;
	CPI  R16,82
	BRNE _0x6
	RCALL SUBOPT_0x4
	STS  _Ring,R30
	STS  _Ring+1,R31
; 0000 0073         if (data=='I')
_0x6:
	CPI  R16,73
	BRNE _0x7
; 0000 0074             {
; 0000 0075             if (Ring==1) Ring++;
	RCALL SUBOPT_0x3
	SBIW R26,1
	BRNE _0x8
	RCALL SUBOPT_0x5
; 0000 0076             else  Ring=0;
	RJMP _0x9
_0x8:
	RCALL SUBOPT_0x6
; 0000 0077             }
_0x9:
; 0000 0078         if (data=='N')
_0x7:
	CPI  R16,78
	BRNE _0xA
; 0000 0079             {
; 0000 007A             if (Ring==2) Ring++;
	RCALL SUBOPT_0x3
	SBIW R26,2
	BRNE _0xB
	RCALL SUBOPT_0x5
; 0000 007B             else  Ring=0;
	RJMP _0xC
_0xB:
	RCALL SUBOPT_0x6
; 0000 007C             }
_0xC:
; 0000 007D         if (data=='G')
_0xA:
	CPI  R16,71
	BRNE _0xD
; 0000 007E             {
; 0000 007F             if (Ring==3) Ring++;                        // Ring = 4   
	RCALL SUBOPT_0x3
	SBIW R26,3
	BRNE _0xE
	RCALL SUBOPT_0x5
; 0000 0080             else  Ring=0;
	RJMP _0xF
_0xE:
	RCALL SUBOPT_0x6
; 0000 0081             }
_0xF:
; 0000 0082         }
_0xD:
; 0000 0083       if (Deact!=5)
_0x5:
	RCALL SUBOPT_0x7
	SBIW R26,5
	BREQ _0x10
; 0000 0084         {
; 0000 0085         if (data=='D') Deact=1;                         //     -   "DEACT"
	CPI  R16,68
	BRNE _0x11
	RCALL SUBOPT_0x4
	STS  _Deact,R30
	STS  _Deact+1,R31
; 0000 0086         if (data=='E')                                  //  Deact==5    GPS 
_0x11:
	CPI  R16,69
	BRNE _0x12
; 0000 0087             {
; 0000 0088             if (Deact==1) Deact++;
	RCALL SUBOPT_0x7
	SBIW R26,1
	BRNE _0x13
	RCALL SUBOPT_0x8
; 0000 0089             else  Deact=0;
	RJMP _0x14
_0x13:
	RCALL SUBOPT_0x9
; 0000 008A             }
_0x14:
; 0000 008B         if (data=='A')
_0x12:
	CPI  R16,65
	BRNE _0x15
; 0000 008C             {
; 0000 008D             if (Deact==2) Deact++;
	RCALL SUBOPT_0x7
	SBIW R26,2
	BRNE _0x16
	RCALL SUBOPT_0x8
; 0000 008E             else  Deact=0;
	RJMP _0x17
_0x16:
	RCALL SUBOPT_0x9
; 0000 008F             }
_0x17:
; 0000 0090         if (data=='C')
_0x15:
	CPI  R16,67
	BRNE _0x18
; 0000 0091             {
; 0000 0092             if (Deact==3) Deact++;
	RCALL SUBOPT_0x7
	SBIW R26,3
	BRNE _0x19
	RCALL SUBOPT_0x8
; 0000 0093             else  Deact=0;
	RJMP _0x1A
_0x19:
	RCALL SUBOPT_0x9
; 0000 0094             }
_0x1A:
; 0000 0095         if (data=='T')
_0x18:
	CPI  R16,84
	BRNE _0x1B
; 0000 0096             {
; 0000 0097             if (Deact==4) Deact++;
	RCALL SUBOPT_0x7
	SBIW R26,4
	BRNE _0x1C
	RCALL SUBOPT_0x8
; 0000 0098             else  Deact=0;
	RJMP _0x1D
_0x1C:
	RCALL SUBOPT_0x9
; 0000 0099             }
_0x1D:
; 0000 009A 
; 0000 009B         if((data==0x0d)||(data==0x0a))
_0x1B:
	CPI  R16,13
	BREQ _0x1F
	CPI  R16,10
	BRNE _0x1E
_0x1F:
; 0000 009C             {
; 0000 009D             if(i>0)
	LDS  R26,_i
	CPI  R26,LOW(0x1)
	BRLO _0x21
; 0000 009E                 {
; 0000 009F                 data = 0;
	LDI  R16,LOW(0)
; 0000 00A0                 }
; 0000 00A1             }
_0x21:
; 0000 00A2         MyBuffer[i]=data;
_0x1E:
	LDS  R30,_i
	RCALL SUBOPT_0xA
	ST   Z,R16
; 0000 00A3         i ++;                                           //  
	LDS  R30,_i
	SUBI R30,-LOW(1)
	RCALL SUBOPT_0xB
; 0000 00A4         if (i == RX_BUFFER_SIZE)                        //     
	LDS  R26,_i
	CPI  R26,LOW(0x96)
	BRNE _0x22
; 0000 00A5             {                                           //     
; 0000 00A6             i=0;                                        //   = 0
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xB
; 0000 00A7             }
; 0000 00A8 
; 0000 00A9       }
_0x22:
; 0000 00AA     }
_0x10:
	LD   R16,Y+
	LD   R17,Y+
	RCALL SUBOPT_0x2
	RETI
; .FEND
;//-----------------------------------------------------------------
;// Analog Comparator interrupt service routine
;//-----------------------------------------------------------------
;interrupt [ANA_COMP] void ana_comp_isr(void)
; 0000 00AF {
_ana_comp_isr:
; .FSTART _ana_comp_isr
	ST   -Y,R30
	ST   -Y,R31
; 0000 00B0 // Place your code here
; 0000 00B1 //if (PIND.4==0)
; 0000 00B2 Temperat = 1;                                           //  D4 = Gnd   -4 1   DS ...
	RCALL SUBOPT_0xC
; 0000 00B3 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
; .FEND
;//=================================================================
;//-----------------------------------------------------------------
;//     SMS
;void chislo( int cislo)                                 //        
; 0000 00B8     {                                                   //  -  D C B A
_chislo:
; .FSTART _chislo
; 0000 00B9     A = B = C  = cislo;
	RCALL SUBOPT_0xD
;	cislo -> Y+0
	LD   R30,Y
	LDD  R31,Y+1
	MOVW R10,R30
	MOVW R8,R30
	MOVW R6,R30
; 0000 00BA     C = C / 100 ;                                       //    (  100)
	MOVW R26,R10
	RCALL SUBOPT_0xE
	RCALL __DIVW21U
	MOVW R10,R30
; 0000 00BB     B = A = B % 100 ;                                   //     100
	MOVW R26,R8
	RCALL SUBOPT_0xE
	RCALL __MODW21U
	MOVW R6,R30
	MOVW R8,R30
; 0000 00BC     B = B / 10 ;                                        //    (  10)
	MOVW R26,R8
	RCALL SUBOPT_0xF
	RCALL __DIVW21U
	MOVW R8,R30
; 0000 00BD     A = A % 10 ;                                        //     (     ...
	MOVW R26,R6
	RCALL SUBOPT_0xF
	RCALL __MODW21U
	MOVW R6,R30
; 0000 00BE 
; 0000 00BF     if (znak>0) D=0x2d;
	RCALL SUBOPT_0x10
	RCALL __CPW02
	BRGE _0x23
	LDI  R30,LOW(45)
	LDI  R31,HIGH(45)
	RJMP _0x1CB
; 0000 00C0     else D = '+';
_0x23:
	LDI  R30,LOW(43)
	LDI  R31,HIGH(43)
_0x1CB:
	MOVW R12,R30
; 0000 00C1     if (C==0)                                           //       (  )   ...
	MOV  R0,R10
	OR   R0,R11
	BRNE _0x25
; 0000 00C2         {
; 0000 00C3         C=D;
	MOVW R10,R12
; 0000 00C4         D=0x20;
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	MOVW R12,R30
; 0000 00C5         }
; 0000 00C6 
; 0000 00C7     Dt=D;
_0x25:
	STS  _Dt,R12
; 0000 00C8     if (C<10) Ct=C|0x30;
	RCALL SUBOPT_0xF
	CP   R10,R30
	CPC  R11,R31
	BRSH _0x26
	MOV  R30,R10
	ORI  R30,LOW(0x30)
	STS  _Ct,R30
; 0000 00C9     else Ct=C;
	RJMP _0x27
_0x26:
	STS  _Ct,R10
; 0000 00CA     Bt=B|0x30;
_0x27:
	MOV  R30,R8
	ORI  R30,LOW(0x30)
	STS  _Bt,R30
; 0000 00CB     At=A|0x30;
	MOV  R30,R6
	ORI  R30,LOW(0x30)
	MOV  R4,R30
; 0000 00CC     }
	ADIW R28,2
	RET
; .FEND
;//-------------------------------------------------------------
;//-------------    DS18b20 --------------
;//-------------------------------------------------------------
;void _Temper(void)                                      //      
; 0000 00D1     {
__Temper:
; .FSTART __Temper
; 0000 00D2 
; 0000 00D3     if (devices==0)
	TST  R5
	BRNE _0x28
; 0000 00D4         {
; 0000 00D5         devices=w1_search(DS18B20_SEARCH_ROM_CMD,rom_code); //        1-Wire
	LDI  R30,LOW(240)
	ST   -Y,R30
	LDI  R26,LOW(_rom_code)
	LDI  R27,HIGH(_rom_code)
	RCALL _w1_search
	MOV  R5,R30
; 0000 00D6         ds18b20_init(0,-35,35,DS18B20_12BIT_RES);       //    12  
	RCALL SUBOPT_0x11
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(221)
	ST   -Y,R30
	LDI  R30,LOW(35)
	ST   -Y,R30
	LDI  R26,LOW(3)
	RCALL _ds18b20_init
; 0000 00D7         delay_ms(500);
	RCALL SUBOPT_0x12
; 0000 00D8         }
; 0000 00D9     else {
	RJMP _0x29
_0x28:
; 0000 00DA         temp1 = ds18b20_temperature(&rom_code[0][0]);   //     
	LDI  R26,LOW(_rom_code)
	LDI  R27,HIGH(_rom_code)
	RCALL _ds18b20_temperature
	RCALL SUBOPT_0x13
; 0000 00DB         if ((temp1 < 100) & (temp1 > -60))              //   
	RCALL SUBOPT_0x14
	__GETD1N 0x42C80000
	RCALL __LTF12
	MOV  R0,R30
	RCALL SUBOPT_0x14
	__GETD1N 0xC2700000
	RCALL __GTF12
	AND  R30,R0
	BREQ _0x2A
; 0000 00DC             {
; 0000 00DD             //temp1= temp1;
; 0000 00DE             if (temp1>0)znak=0;                         //    - (   znak=1)
	RCALL SUBOPT_0x14
	RCALL __CPD02
	BRGE _0x2B
	LDI  R30,LOW(0)
	STS  _znak,R30
	STS  _znak+1,R30
; 0000 00DF             else znak=1;
	RJMP _0x2C
_0x2B:
	RCALL SUBOPT_0x4
	STS  _znak,R30
	STS  _znak+1,R31
; 0000 00E0             temp1=temp1*10;                             //   (      ...
_0x2C:
	RCALL SUBOPT_0x14
	__GETD1N 0x41200000
	RCALL __MULF12
	RCALL SUBOPT_0x13
; 0000 00E1             if (znak==1)
	RCALL SUBOPT_0x10
	SBIW R26,1
	BRNE _0x2D
; 0000 00E2                 {
; 0000 00E3                 temp1 = -temp1;                         //         
	RCALL SUBOPT_0x15
	RCALL __ANEGF1
	RCALL SUBOPT_0x13
; 0000 00E4                 if (temp1>ustavka*10) Temperat = 1;     //  D4 = 1  DS18b20     -16"C    ...
	RCALL SUBOPT_0x14
	__GETD1N 0x43200000
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0x2E
	RCALL SUBOPT_0xC
; 0000 00E5                 }
_0x2E:
; 0000 00E6             Bt1 = (int) temp1;
_0x2D:
	RCALL SUBOPT_0x15
	RCALL __CFD1
	STS  _Bt1,R30
	STS  _Bt1+1,R31
; 0000 00E7             chislo(Bt1);                                //        
	LDS  R26,_Bt1
	LDS  R27,_Bt1+1
	RCALL _chislo
; 0000 00E8             }
; 0000 00E9         }
_0x2A:
_0x29:
; 0000 00EA     }
	RET
; .FEND
;//-----------------------------------------------------------------
;//-------       ----------
;//-----------------------------------------------------------------
;int AON_(void)
; 0000 00EF     { char y, x =0;
_AON_:
; .FSTART _AON_
; 0000 00F0     rx_cursor = 0;                                      //   (    UART)
	RCALL __SAVELOCR2
;	y -> R17
;	x -> R16
	LDI  R16,0
	RCALL SUBOPT_0x16
; 0000 00F1     delay_ms(1000);                                     //       
	RCALL SUBOPT_0x17
; 0000 00F2     x = i;
	LDS  R16,_i
; 0000 00F3     #asm("cli")                                         //  
	cli
; 0000 00F4     i = 0;                                              //   UART 
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xB
; 0000 00F5     #asm("sei")                                         //  
	sei
; 0000 00F6     if (x==0) return 0;                                 //   -   
	CPI  R16,0
	BRNE _0x2F
	RCALL SUBOPT_0x11
	RJMP _0x2020006
; 0000 00F7     y=0;
_0x2F:
	LDI  R17,LOW(0)
; 0000 00F8 
; 0000 00F9     for ( rx_cursor=0;rx_cursor!=x;rx_cursor++)
	RCALL SUBOPT_0x16
_0x31:
	LDS  R26,_rx_cursor
	CP   R16,R26
	BREQ _0x32
; 0000 00FA         {
; 0000 00FB         if (y==12) return 1;                            //       
	CPI  R17,12
	BRNE _0x33
	RCALL SUBOPT_0x4
	RJMP _0x2020006
; 0000 00FC         if (rx_cursor==RX_BUFFER_SIZE) return 0;        //    -  
_0x33:
	LDS  R26,_rx_cursor
	CPI  R26,LOW(0x96)
	BRNE _0x34
	RCALL SUBOPT_0x11
	RJMP _0x2020006
; 0000 00FD         if (cmd_8[y]==MyBuffer[rx_cursor])
_0x34:
	MOV  R30,R17
	LDI  R31,0
	RCALL SUBOPT_0x18
	LD   R26,Z
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0xA
	LD   R30,Z
	CP   R30,R26
	BRNE _0x35
; 0000 00FE             {
; 0000 00FF             y++;
	SUBI R17,-1
; 0000 0100             }
; 0000 0101         }
_0x35:
	RCALL SUBOPT_0x1A
	RJMP _0x31
_0x32:
; 0000 0102     if (y<12) return 0;                                 //    (   )
	CPI  R17,12
	BRSH _0x36
	RCALL SUBOPT_0x11
	RJMP _0x2020006
; 0000 0103     }
_0x36:
	RJMP _0x2020006
; .FEND
;//-----------------------------------------------------------------
;//------------   ( ) --------------------
;//-----------------------------------------------------------------
;void Otboy(void)
; 0000 0108     {
_Otboy:
; .FSTART _Otboy
; 0000 0109 
; 0000 010A     for(z=0;cmd_4[z]!='';z++)                           //  
	RCALL SUBOPT_0x1B
_0x38:
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
	BREQ _0x39
; 0000 010B         {
; 0000 010C         UDR = cmd_4[z];
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1E
; 0000 010D         delay_ms(100);
	RCALL SUBOPT_0x1F
; 0000 010E         }
	RCALL SUBOPT_0x20
	RJMP _0x38
_0x39:
; 0000 010F     UDR = ('\r');
	RCALL SUBOPT_0x21
; 0000 0110     delay_ms(1500);
	RCALL SUBOPT_0x22
; 0000 0111     }
	RET
; .FEND
;//----------------------------------------------------------
;//-------------   GSM Sim800L --------------
;//----------------------------------------------------------
;void _Start_telef(void)
; 0000 0116     { int i;
__Start_telef:
; .FSTART __Start_telef
; 0000 0117 //   
; 0000 0118 PORTB.3 = 0;                                            //   GSM Sim800L
	RCALL __SAVELOCR2
;	i -> R16,R17
	CBI  0x18,3
; 0000 0119 for (i=0;i<2;i++)
	RCALL SUBOPT_0x23
_0x3D:
	__CPWRN 16,17,2
	BRGE _0x3E
; 0000 011A     {                                                   // 1   Reset = 0
; 0000 011B     PORTC.1 = 1;
	SBI  0x15,1
; 0000 011C     delay_ms (100);
	RCALL SUBOPT_0x1F
; 0000 011D     PORTC.2 = 1;
	SBI  0x15,2
; 0000 011E     delay_ms (100);
	RCALL SUBOPT_0x1F
; 0000 011F     PORTC.3 = 1;
	SBI  0x15,3
; 0000 0120     delay_ms (100);
	RCALL SUBOPT_0x1F
; 0000 0121     PORTC.1 = 0;
	CBI  0x15,1
; 0000 0122     delay_ms (100);
	RCALL SUBOPT_0x1F
; 0000 0123     PORTC.2 = 0;
	CBI  0x15,2
; 0000 0124     delay_ms (100);
	RCALL SUBOPT_0x1F
; 0000 0125     PORTC.3 = 0;
	CBI  0x15,3
; 0000 0126     delay_ms (100);
	RCALL SUBOPT_0x1F
; 0000 0127     }
	RCALL SUBOPT_0x24
	RJMP _0x3D
_0x3E:
; 0000 0128 PORTB.3 = 1;                                            //  Reset  GSM   Res = 1
	SBI  0x18,3
; 0000 0129 for (i=0;i<50;i++)
	RCALL SUBOPT_0x23
_0x4E:
	__CPWRN 16,17,50
	BRGE _0x4F
; 0000 012A     {                                                   //  20    
; 0000 012B     PORTC.3 = 1;
	SBI  0x15,3
; 0000 012C     delay_ms (100);
	RCALL SUBOPT_0x1F
; 0000 012D     PORTC.3 = 0;
	CBI  0x15,3
; 0000 012E     PORTC.2 = 1;
	SBI  0x15,2
; 0000 012F     delay_ms (100);
	RCALL SUBOPT_0x1F
; 0000 0130     PORTC.2 = 0;
	CBI  0x15,2
; 0000 0131     PORTC.1 = 1;
	SBI  0x15,1
; 0000 0132     delay_ms (100);
	RCALL SUBOPT_0x1F
; 0000 0133     PORTC.1 = 0;
	CBI  0x15,1
; 0000 0134     delay_ms (100);
	RCALL SUBOPT_0x1F
; 0000 0135     }
	RCALL SUBOPT_0x24
	RJMP _0x4E
_0x4F:
; 0000 0136     for(z=0;cmd_1[z]!='';z++)                           //     
	RCALL SUBOPT_0x1B
_0x5D:
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x1D
	BREQ _0x5E
; 0000 0137         {
; 0000 0138         UDR = cmd_1[z];
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x1E
; 0000 0139         delay_ms(interval);
	RCALL SUBOPT_0x26
; 0000 013A         }
	RCALL SUBOPT_0x20
	RJMP _0x5D
_0x5E:
; 0000 013B     UDR = ('\r');
	RCALL SUBOPT_0x21
; 0000 013C     delay_ms(500);
	RCALL SUBOPT_0x12
; 0000 013D     for(z=0;cmd_0[z]!='';z++)                           //    UART
	RCALL SUBOPT_0x1B
_0x60:
	RCALL SUBOPT_0x27
	RCALL SUBOPT_0x1D
	BREQ _0x61
; 0000 013E         {
; 0000 013F         UDR = cmd_0[z];
	RCALL SUBOPT_0x27
	RCALL SUBOPT_0x1E
; 0000 0140         delay_ms(interval);
	RCALL SUBOPT_0x26
; 0000 0141         }
	RCALL SUBOPT_0x20
	RJMP _0x60
_0x61:
; 0000 0142     UDR = ('\r');
	RCALL SUBOPT_0x21
; 0000 0143     delay_ms(500);
	RCALL SUBOPT_0x12
; 0000 0144     for(z=0;cmd_9[z]!='';z++)                           //     - 
	RCALL SUBOPT_0x1B
_0x63:
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x1D
	BREQ _0x64
; 0000 0145         {
; 0000 0146         UDR = cmd_9[z];
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x1E
; 0000 0147         delay_ms(interval);
	RCALL SUBOPT_0x26
; 0000 0148         }
	RCALL SUBOPT_0x20
	RJMP _0x63
_0x64:
; 0000 0149     UDR = ('\r');
	RCALL SUBOPT_0x21
; 0000 014A     delay_ms(500);
	RCALL SUBOPT_0x12
; 0000 014B     }
	RJMP _0x2020006
; .FEND
;//------------------------------------------------------------
;//--------------- --------------------------------
;//------------------------------------------------------------
;void  bait_seg( unsigned int u0)
; 0000 0150     { unsigned char u1,u2,u3,u4=0;
_bait_seg:
; .FSTART _bait_seg
; 0000 0151 
; 0000 0152 
; 0000 0153             u3 = u4 = u0;                               //    UNICOD  4  ( 0x043C = 0 ...
	RCALL SUBOPT_0xD
	RCALL __SAVELOCR4
;	u0 -> Y+4
;	u1 -> R17
;	u2 -> R16
;	u3 -> R19
;	u4 -> R18
	LDI  R18,0
	LDD  R30,Y+4
	MOV  R18,R30
	MOV  R19,R30
; 0000 0154             u4 = u4 & 0x0F;
	ANDI R18,LOW(15)
; 0000 0155             if (u4>9)
	CPI  R18,10
	BRLO _0x65
; 0000 0156                 {
; 0000 0157                 if (u4==0x0A) u4 = 'A';
	CPI  R18,10
	BRNE _0x66
	LDI  R18,LOW(65)
; 0000 0158                 if (u4==0x0B) u4 = 'B';
_0x66:
	CPI  R18,11
	BRNE _0x67
	LDI  R18,LOW(66)
; 0000 0159                 if (u4==0x0C) u4 = 'C';
_0x67:
	CPI  R18,12
	BRNE _0x68
	LDI  R18,LOW(67)
; 0000 015A                 if (u4==0x0D) u4 = 'D';
_0x68:
	CPI  R18,13
	BRNE _0x69
	LDI  R18,LOW(68)
; 0000 015B                 if (u4==0x0E) u4 = 'E';
_0x69:
	CPI  R18,14
	BRNE _0x6A
	LDI  R18,LOW(69)
; 0000 015C                 if (u4==0x0F) u4 = 'F';
_0x6A:
	CPI  R18,15
	BRNE _0x6B
	LDI  R18,LOW(70)
; 0000 015D                 }
_0x6B:
; 0000 015E             else u4 = u4 + 0x30;
	RJMP _0x6C
_0x65:
	SUBI R18,-LOW(48)
; 0000 015F 
; 0000 0160             u3 = u3 & 0xF0;
_0x6C:
	ANDI R19,LOW(240)
; 0000 0161             u3 = u3 >> 4;
	SWAP R19
	ANDI R19,0xF
; 0000 0162             if (u3>9)
	CPI  R19,10
	BRLO _0x6D
; 0000 0163                 {
; 0000 0164                 if (u3==0x0A) u3 = 'A';
	CPI  R19,10
	BRNE _0x6E
	LDI  R19,LOW(65)
; 0000 0165                 if (u3==0x0B) u3 = 'B';
_0x6E:
	CPI  R19,11
	BRNE _0x6F
	LDI  R19,LOW(66)
; 0000 0166                 if (u3==0x0C) u3 = 'C';
_0x6F:
	CPI  R19,12
	BRNE _0x70
	LDI  R19,LOW(67)
; 0000 0167                 if (u3==0x0D) u3 = 'D';
_0x70:
	CPI  R19,13
	BRNE _0x71
	LDI  R19,LOW(68)
; 0000 0168                 if (u3==0x0E) u3 = 'E';
_0x71:
	CPI  R19,14
	BRNE _0x72
	LDI  R19,LOW(69)
; 0000 0169                 if (u3==0x0F) u3 = 'F';
_0x72:
	CPI  R19,15
	BRNE _0x73
	LDI  R19,LOW(70)
; 0000 016A                 }
_0x73:
; 0000 016B             else u3 = u3 + 0x30;
	RJMP _0x74
_0x6D:
	SUBI R19,-LOW(48)
; 0000 016C 
; 0000 016D             u0 = u0 & 0xFF00;
_0x74:
	LDD  R30,Y+4
	ANDI R30,LOW(0xFF00)
	STD  Y+4,R30
; 0000 016E             u0 = u0 >> 8;
	LDD  R30,Y+5
	ANDI R31,HIGH(0x0)
	STD  Y+4,R30
	STD  Y+4+1,R31
; 0000 016F             u1 = u2 = u0;
	LDD  R30,Y+4
	RCALL SUBOPT_0x29
; 0000 0170             u2 = u2 & 0x0F;
; 0000 0171             if (u2>9)
	BRLO _0x75
; 0000 0172                 {
; 0000 0173                 if (u2==0x0A) u2 = 'A';
	CPI  R16,10
	BRNE _0x76
	LDI  R16,LOW(65)
; 0000 0174                 if (u2==0x0B) u2 = 'B';
_0x76:
	CPI  R16,11
	BRNE _0x77
	LDI  R16,LOW(66)
; 0000 0175                 if (u2==0x0C) u2 = 'C';
_0x77:
	CPI  R16,12
	BRNE _0x78
	LDI  R16,LOW(67)
; 0000 0176                 if (u2==0x0D) u2 = 'D';
_0x78:
	CPI  R16,13
	BRNE _0x79
	LDI  R16,LOW(68)
; 0000 0177                 if (u2==0x0E) u2 = 'E';
_0x79:
	CPI  R16,14
	BRNE _0x7A
	LDI  R16,LOW(69)
; 0000 0178                 if (u2==0x0F) u2 = 'F';
_0x7A:
	CPI  R16,15
	BRNE _0x7B
	LDI  R16,LOW(70)
; 0000 0179                 }
_0x7B:
; 0000 017A             else u2 = u2 + 0x30;
	RJMP _0x7C
_0x75:
	SUBI R16,-LOW(48)
; 0000 017B             u1 = u1 & 0xF0;
_0x7C:
	RCALL SUBOPT_0x2A
; 0000 017C             u1 = u1 >> 4;
; 0000 017D             if (u1>9)
	BRLO _0x7D
; 0000 017E                 {
; 0000 017F                 if (u1==0x0A) u1 = 'A';
	CPI  R17,10
	BRNE _0x7E
	LDI  R17,LOW(65)
; 0000 0180                 if (u1==0x0B) u1 = 'B';
_0x7E:
	CPI  R17,11
	BRNE _0x7F
	LDI  R17,LOW(66)
; 0000 0181                 if (u1==0x0C) u1 = 'C';
_0x7F:
	CPI  R17,12
	BRNE _0x80
	LDI  R17,LOW(67)
; 0000 0182                 if (u1==0x0D) u1 = 'D';
_0x80:
	CPI  R17,13
	BRNE _0x81
	LDI  R17,LOW(68)
; 0000 0183                 if (u1==0x0E) u1 = 'E';
_0x81:
	CPI  R17,14
	BRNE _0x82
	LDI  R17,LOW(69)
; 0000 0184                 if (u1==0x0F) u1 = 'F';
_0x82:
	CPI  R17,15
	BRNE _0x83
	LDI  R17,LOW(70)
; 0000 0185                 }
_0x83:
; 0000 0186             else u1 = u1 + 0x30;
	RJMP _0x84
_0x7D:
	SUBI R17,-LOW(48)
; 0000 0187             if (SMS_dlinna<140-3)
_0x84:
	LDS  R26,_SMS_dlinna
	CPI  R26,LOW(0x89)
	BRSH _0x85
; 0000 0188                 {                                       //   4    PDU SMS ,   
; 0000 0189                 SMS_text[SMS_dlinna] = u1;
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x2C
	ST   Z,R17
; 0000 018A                 SMS_dlinna++;
	RCALL SUBOPT_0x2D
; 0000 018B                 SMS_text[SMS_dlinna] = u2;
	ST   Z,R16
; 0000 018C                 SMS_dlinna++;
	RCALL SUBOPT_0x2D
; 0000 018D                 SMS_text[SMS_dlinna] = u3;
	ST   Z,R19
; 0000 018E                 SMS_dlinna++;
	RCALL SUBOPT_0x2D
; 0000 018F                 SMS_text[SMS_dlinna] = u4;
	ST   Z,R18
; 0000 0190                 SMS_dlinna++;
	RCALL SUBOPT_0x2B
	SUBI R30,-LOW(1)
	STS  _SMS_dlinna,R30
; 0000 0191                 }
; 0000 0192 
; 0000 0193 
; 0000 0194 //    return u1 , u2;
; 0000 0195     }
_0x85:
	RJMP _0x2020003
; .FEND
;//-------------------------------------------------------------                                                          ...
;//-------------  PUD   SMS -------------
;//-------------------------------------------------------------
;void sms_PUD_text (void)                                //    SMS
; 0000 019A     { unsigned int u0=0;
_sms_PUD_text:
; .FSTART _sms_PUD_text
; 0000 019B    SMS_dlinna = 0;
	RCALL __SAVELOCR2
;	u0 -> R16,R17
	RCALL SUBOPT_0x23
	LDI  R30,LOW(0)
	STS  _SMS_dlinna,R30
; 0000 019C    if (_flag == 0)                                      // SMS - "."
	LDS  R30,__flag
	LDS  R31,__flag+1
	SBIW R30,0
	BRNE _0x86
; 0000 019D         {
; 0000 019E         for(z=0;cmd_5[z]!='';z++)                       //   SMS
	RCALL SUBOPT_0x1B
_0x88:
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x1D
	BREQ _0x89
; 0000 019F             {
; 0000 01A0             u0 = cmd_5[z];
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x2F
; 0000 01A1             if (u0>0x7F)
	BRLO _0x8A
; 0000 01A2                 {
; 0000 01A3                 u0 = u0 + 0x0350;                       //     UNICOD
	RCALL SUBOPT_0x30
; 0000 01A4                 }
; 0000 01A5             else u0 = u0 & 0x00FF;
	RJMP _0x8B
_0x8A:
	ANDI R17,HIGH(255)
; 0000 01A6             bait_seg(u0);                               //    UNICOD  4  ( 0x043C = 0 ...
_0x8B:
	RCALL SUBOPT_0x31
; 0000 01A7             }
	RCALL SUBOPT_0x20
	RJMP _0x88
_0x89:
; 0000 01A8         }
; 0000 01A9     if (_flag == 1)                                     // SMS - "."
_0x86:
	RCALL SUBOPT_0x32
	SBIW R26,1
	BRNE _0x8C
; 0000 01AA         {
; 0000 01AB         for(z=0;cmd_6[z]!='';z++)                       //   SMS
	RCALL SUBOPT_0x1B
_0x8E:
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x1D
	BREQ _0x8F
; 0000 01AC             {
; 0000 01AD             u0 = cmd_6[z];
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x2F
; 0000 01AE             if (u0>0x7F)
	BRLO _0x90
; 0000 01AF                 {
; 0000 01B0                 u0 = u0 + 0x0350;                       //     UNICOD
	RCALL SUBOPT_0x30
; 0000 01B1                 }
; 0000 01B2             else u0 = u0 & 0x00FF;
	RJMP _0x91
_0x90:
	ANDI R17,HIGH(255)
; 0000 01B3             bait_seg(u0);
_0x91:
	RCALL SUBOPT_0x31
; 0000 01B4             }
	RCALL SUBOPT_0x20
	RJMP _0x8E
_0x8F:
; 0000 01B5         }
; 0000 01B6     if (_flag == 2)
_0x8C:
	RCALL SUBOPT_0x32
	SBIW R26,2
	BRNE _0x92
; 0000 01B7         {                                               // SMS - " "
; 0000 01B8         for(z=0;cmd_7[z]!='';z++)                       //   SMS
	RCALL SUBOPT_0x1B
_0x94:
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x1D
	BREQ _0x95
; 0000 01B9            {
; 0000 01BA             u0 = cmd_7[z];
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x2F
; 0000 01BB             if (u0>0x7F)
	BRLO _0x96
; 0000 01BC                 {
; 0000 01BD                 u0 = u0 + 0x0350;                       //     UNICOD
	RCALL SUBOPT_0x30
; 0000 01BE                 }
; 0000 01BF             else u0 = u0 & 0x00FF;
	RJMP _0x97
_0x96:
	ANDI R17,HIGH(255)
; 0000 01C0             bait_seg(u0);
_0x97:
	RCALL SUBOPT_0x31
; 0000 01C1             }
	RCALL SUBOPT_0x20
	RJMP _0x94
_0x95:
; 0000 01C2         }
; 0000 01C3     if (_flag == 3)
_0x92:
	RCALL SUBOPT_0x32
	SBIW R26,3
	BRNE _0x98
; 0000 01C4         {                                               // SMS - " "          
; 0000 01C5         for(z=0;cmd_11[z]!='';z++)                      //   SMS
	RCALL SUBOPT_0x1B
_0x9A:
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x1D
	BREQ _0x9B
; 0000 01C6             {
; 0000 01C7             u0 = cmd_11[z];
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x2F
; 0000 01C8             if (u0>0x7F)
	BRLO _0x9C
; 0000 01C9                 {
; 0000 01CA                 u0 = u0 + 0x0350;                       //     UNICOD
	RCALL SUBOPT_0x30
; 0000 01CB                 }
; 0000 01CC             else u0 = u0 & 0x00FF;
	RJMP _0x9D
_0x9C:
	ANDI R17,HIGH(255)
; 0000 01CD             bait_seg(u0);
_0x9D:
	RCALL SUBOPT_0x31
; 0000 01CE             }
	RCALL SUBOPT_0x20
	RJMP _0x9A
_0x9B:
; 0000 01CF         }
; 0000 01D0 //---------------------------------
; 0000 01D1     if (_flag == 4)
_0x98:
	RCALL SUBOPT_0x32
	SBIW R26,4
	BRNE _0x9E
; 0000 01D2         {                                               // SMS - "  "             
; 0000 01D3         for(z=0;cmd_12[z]!='';z++)                      //   SMS
	RCALL SUBOPT_0x1B
_0xA0:
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x1D
	BREQ _0xA1
; 0000 01D4             {
; 0000 01D5             u0 = cmd_12[z];
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x2F
; 0000 01D6             if (u0>0x7F)
	BRLO _0xA2
; 0000 01D7                 {
; 0000 01D8                 u0 = u0 + 0x0350;                       //     UNICOD
	RCALL SUBOPT_0x30
; 0000 01D9                 }
; 0000 01DA             else u0 = u0 & 0x00FF;
	RJMP _0xA3
_0xA2:
	ANDI R17,HIGH(255)
; 0000 01DB             bait_seg(u0);
_0xA3:
	RCALL SUBOPT_0x31
; 0000 01DC             }
	RCALL SUBOPT_0x20
	RJMP _0xA0
_0xA1:
; 0000 01DD         }
; 0000 01DE     bait_seg(0x000D);
_0x9E:
	LDI  R26,LOW(13)
	RCALL SUBOPT_0x37
; 0000 01DF //----------------------------------
; 0000 01E0     for(z=0;cmd_14[z]!='';z++)                          //   SMS   " Tem "
	RCALL SUBOPT_0x1B
_0xA5:
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x1D
	BREQ _0xA6
; 0000 01E1             {
; 0000 01E2             u0 = cmd_14[z];
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x2F
; 0000 01E3             if (u0>0x7F)
	BRLO _0xA7
; 0000 01E4                 {
; 0000 01E5                 u0 = u0 + 0x0350;                       //     UNICOD
	RCALL SUBOPT_0x30
; 0000 01E6                 }
; 0000 01E7             else u0 = u0 & 0x00FF;
	RJMP _0xA8
_0xA7:
	ANDI R17,HIGH(255)
; 0000 01E8             bait_seg(u0);
_0xA8:
	RCALL SUBOPT_0x31
; 0000 01E9             }
	RCALL SUBOPT_0x20
	RJMP _0xA5
_0xA6:
; 0000 01EA     bait_seg(Dt);
	LDS  R26,_Dt
	RCALL SUBOPT_0x39
; 0000 01EB     bait_seg(Ct);
	LDS  R26,_Ct
	RCALL SUBOPT_0x39
; 0000 01EC     bait_seg(Bt);
	LDS  R26,_Bt
	RCALL SUBOPT_0x39
; 0000 01ED     bait_seg(',');
	LDI  R26,LOW(44)
	RCALL SUBOPT_0x37
; 0000 01EE     bait_seg(At);
	MOV  R26,R4
	RCALL SUBOPT_0x39
; 0000 01EF     bait_seg('"');
	LDI  R26,LOW(34)
	RCALL SUBOPT_0x37
; 0000 01F0     bait_seg('C');
	LDI  R26,LOW(67)
	RCALL SUBOPT_0x37
; 0000 01F1 //SMS_dlinnaE = SMS_dlinna;
; 0000 01F2     }
	RJMP _0x2020006
; .FEND
;
;//-------------------------------------------------------------
;//-------------   PUD SMS --------------------
;//-------------------------------------------------------------
;void sms_zagolovok (void)
; 0000 01F8     {  unsigned char u2,u3=0; unsigned char e1=0;
_sms_zagolovok:
; .FSTART _sms_zagolovok
; 0000 01F9 
; 0000 01FA     for(z=0;z<10;z++)                                   //   PUD SMS
	RCALL __SAVELOCR4
;	u2 -> R17
;	u3 -> R16
;	e1 -> R19
	LDI  R16,0
	LDI  R19,0
	RCALL SUBOPT_0x1B
_0xAA:
	RCALL SUBOPT_0x3A
	SBIW R26,10
	BRSH _0xAB
; 0000 01FB         {
; 0000 01FC         u2 = cmd_3[z];
	RCALL SUBOPT_0x3B
	SUBI R30,LOW(-_cmd_3*2)
	SBCI R31,HIGH(-_cmd_3*2)
	LPM  R17,Z
; 0000 01FD         SMS_zag[e1] = u2;
	RCALL SUBOPT_0x3C
; 0000 01FE         e1++;
; 0000 01FF         }
	RCALL SUBOPT_0x20
	RJMP _0xAA
_0xAB:
; 0000 0200     for(z=1;z<12;z++)                                   //     PUD SMS
	RCALL SUBOPT_0x4
	STS  _z,R30
	STS  _z+1,R31
_0xAD:
	RCALL SUBOPT_0x3A
	SBIW R26,12
	BRSH _0xAE
; 0000 0201         {                                               //               ...
; 0000 0202         u3 = cmd_8[z];                                  //  +79113091234  97h 11h 03h 19h 32h F4h
	RCALL SUBOPT_0x3D
	LD   R16,Z
; 0000 0203         z++;
	RCALL SUBOPT_0x20
; 0000 0204         u2 = cmd_8[z];
	RCALL SUBOPT_0x3D
	LD   R17,Z
; 0000 0205 
; 0000 0206         if (z==12) u2 = 'F';
	RCALL SUBOPT_0x3A
	SBIW R26,12
	BRNE _0xAF
	LDI  R17,LOW(70)
; 0000 0207         SMS_zag[e1] = u2;
_0xAF:
	RCALL SUBOPT_0x3C
; 0000 0208         e1++;
; 0000 0209         SMS_zag[e1] = u3;
	RCALL SUBOPT_0x3E
	ST   Z,R16
; 0000 020A         e1++;
	SUBI R19,-1
; 0000 020B         }
	RCALL SUBOPT_0x20
	RJMP _0xAD
_0xAE:
; 0000 020C         SMS_zag[e1] = '0';
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x3F
; 0000 020D         e1++;
; 0000 020E         SMS_zag[e1] = '0';
	RCALL SUBOPT_0x3F
; 0000 020F         e1++;
; 0000 0210         SMS_zag[e1] = '0';
	RCALL SUBOPT_0x3F
; 0000 0211         e1++;
; 0000 0212         SMS_zag[e1] = '8';                              //   PUD SMS
	LDI  R26,LOW(56)
	STD  Z+0,R26
; 0000 0213         e1++;
	SUBI R19,-1
; 0000 0214 
; 0000 0215         u2 = u3 = SMS_dlinna /2;                        //-   SMS  (  2 )  ...
	LDS  R26,_SMS_dlinna
	LDI  R27,0
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RCALL __DIVW21
	RCALL SUBOPT_0x29
; 0000 0216 
; 0000 0217         u3 = u3 & 0x0F;
; 0000 0218         if (u3>9)
	BRLO _0xB0
; 0000 0219             {
; 0000 021A             if (u3==0x0A) u3 = 'A';
	CPI  R16,10
	BRNE _0xB1
	LDI  R16,LOW(65)
; 0000 021B             if (u3==0x0B) u3 = 'B';
_0xB1:
	CPI  R16,11
	BRNE _0xB2
	LDI  R16,LOW(66)
; 0000 021C             if (u3==0x0C) u3 = 'C';
_0xB2:
	CPI  R16,12
	BRNE _0xB3
	LDI  R16,LOW(67)
; 0000 021D             if (u3==0x0D) u3 = 'D';
_0xB3:
	CPI  R16,13
	BRNE _0xB4
	LDI  R16,LOW(68)
; 0000 021E             if (u3==0x0E) u3 = 'E';
_0xB4:
	CPI  R16,14
	BRNE _0xB5
	LDI  R16,LOW(69)
; 0000 021F             if (u3==0x0F) u3 = 'F';
_0xB5:
	CPI  R16,15
	BRNE _0xB6
	LDI  R16,LOW(70)
; 0000 0220             }
_0xB6:
; 0000 0221         else u3 = u3 + 0x30;
	RJMP _0xB7
_0xB0:
	SUBI R16,-LOW(48)
; 0000 0222 
; 0000 0223         u2 = u2 & 0xF0;
_0xB7:
	RCALL SUBOPT_0x2A
; 0000 0224         u2 = u2 >> 4;
; 0000 0225         if (u2>9)
	BRLO _0xB8
; 0000 0226             {
; 0000 0227             if (u2==0x0A) u2 = 'A';
	CPI  R17,10
	BRNE _0xB9
	LDI  R17,LOW(65)
; 0000 0228             if (u2==0x0B) u2 = 'B';
_0xB9:
	CPI  R17,11
	BRNE _0xBA
	LDI  R17,LOW(66)
; 0000 0229             if (u2==0x0C) u2 = 'C';
_0xBA:
	CPI  R17,12
	BRNE _0xBB
	LDI  R17,LOW(67)
; 0000 022A             if (u2==0x0D) u2 = 'D';
_0xBB:
	CPI  R17,13
	BRNE _0xBC
	LDI  R17,LOW(68)
; 0000 022B             if (u2==0x0E) u2 = 'E';
_0xBC:
	CPI  R17,14
	BRNE _0xBD
	LDI  R17,LOW(69)
; 0000 022C             if (u2==0x0F) u2 = 'F';
_0xBD:
	CPI  R17,15
	BRNE _0xBE
	LDI  R17,LOW(70)
; 0000 022D             }
_0xBE:
; 0000 022E         else u2 = u2 + 0x30;
	RJMP _0xBF
_0xB8:
	SUBI R17,-LOW(48)
; 0000 022F 
; 0000 0230         SMS_zag[e1] = u2;
_0xBF:
	RCALL SUBOPT_0x3C
; 0000 0231         e1++;
; 0000 0232         SMS_zag[e1] = u3;
	RCALL SUBOPT_0x3E
	ST   Z,R16
; 0000 0233 
; 0000 0234     }
	RJMP _0x2020005
; .FEND
;//-------------------------------------------------------------
;//------------- SMS------------------------------------
;//-------------------------------------------------------------
;void sms_out (void)                                     //  SMS
; 0000 0239     { unsigned char y1, y2,y3=0;
_sms_out:
; .FSTART _sms_out
; 0000 023A 
; 0000 023B 
; 0000 023C 
; 0000 023D     PORTC.3 = 1;                                        //   SMS
	RCALL __SAVELOCR4
;	y1 -> R17
;	y2 -> R16
;	y3 -> R19
	LDI  R19,0
	SBI  0x15,3
; 0000 023E     _Temper();                                          //       ( )
	RCALL __Temper
; 0000 023F 
; 0000 0240     sms_PUD_text();                                     //    SMS    
	RCALL _sms_PUD_text
; 0000 0241     sms_zagolovok();                                    //   PUD SMS  (   )
	RCALL _sms_zagolovok
; 0000 0242 
; 0000 0243     for(z=0;cmd_1[z]!='';z++)                           //      "AT"
	RCALL SUBOPT_0x1B
_0xC3:
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x1D
	BREQ _0xC4
; 0000 0244         {
; 0000 0245         UDR = cmd_1[z];
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x1E
; 0000 0246         delay_ms(interval);
	RCALL SUBOPT_0x26
; 0000 0247         }
	RCALL SUBOPT_0x20
	RJMP _0xC3
_0xC4:
; 0000 0248     UDR = ('\r');                                       //   ()
	RCALL SUBOPT_0x21
; 0000 0249     delay_ms(500);
	RCALL SUBOPT_0x12
; 0000 024A 
; 0000 024B     for(z=0;cmd_2_1[z]!='';z++)                         //  SMS PUD      "AT+CMGF=0"
	RCALL SUBOPT_0x1B
_0xC6:
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x1D
	BREQ _0xC7
; 0000 024C         {
; 0000 024D         UDR = cmd_2_1[z];
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x1E
; 0000 024E         delay_ms(interval);
	RCALL SUBOPT_0x26
; 0000 024F         }
	RCALL SUBOPT_0x20
	RJMP _0xC6
_0xC7:
; 0000 0250     UDR = ('\r');                                       //   ()
	RCALL SUBOPT_0x21
; 0000 0251     delay_ms(500);
	RCALL SUBOPT_0x12
; 0000 0252     for(z=0;cmd_2_0[z]!='';z++)                         //  SMS PUD   " AT+CSCS="UCS2" "
	RCALL SUBOPT_0x1B
_0xC9:
	RCALL SUBOPT_0x3B
	SUBI R30,LOW(-_cmd_2_0*2)
	SBCI R31,HIGH(-_cmd_2_0*2)
	RCALL SUBOPT_0x1D
	BREQ _0xCA
; 0000 0253         {
; 0000 0254         UDR = cmd_2_0[z];
	RCALL SUBOPT_0x3B
	SUBI R30,LOW(-_cmd_2_0*2)
	SBCI R31,HIGH(-_cmd_2_0*2)
	RCALL SUBOPT_0x1E
; 0000 0255         delay_ms(interval);
	RCALL SUBOPT_0x26
; 0000 0256         }
	RCALL SUBOPT_0x20
	RJMP _0xC9
_0xCA:
; 0000 0257     UDR = ('\r');                                       //   ()
	RCALL SUBOPT_0x21
; 0000 0258     delay_ms(500);
	RCALL SUBOPT_0x12
; 0000 0259 
; 0000 025A 
; 0000 025B     for(z=0;cmd_2_2[z]!='';z++)                         //    SMS PUD   
	RCALL SUBOPT_0x1B
_0xCC:
	RCALL SUBOPT_0x3B
	SUBI R30,LOW(-_cmd_2_2*2)
	SBCI R31,HIGH(-_cmd_2_2*2)
	RCALL SUBOPT_0x1D
	BREQ _0xCD
; 0000 025C         {
; 0000 025D         UDR = cmd_2_2[z];
	RCALL SUBOPT_0x3B
	SUBI R30,LOW(-_cmd_2_2*2)
	SBCI R31,HIGH(-_cmd_2_2*2)
	RCALL SUBOPT_0x1E
; 0000 025E         delay_ms(interval);
	RCALL SUBOPT_0x26
; 0000 025F         }
	RCALL SUBOPT_0x20
	RJMP _0xCC
_0xCD:
; 0000 0260 
; 0000 0261     y1 = y3 = y2  = (SMS_dlinna + 26)/2;                //  PUD   +  ,     ...
	RCALL SUBOPT_0x2B
	LDI  R31,0
	ADIW R30,26
	MOVW R26,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RCALL __DIVW21
	MOV  R16,R30
	MOV  R19,R30
	MOV  R17,R30
; 0000 0262     y1 = y1 / 100;                                      //   2 (  2 )
	MOV  R26,R17
	LDI  R27,0
	RCALL SUBOPT_0xE
	RCALL __DIVW21
	MOV  R17,R30
; 0000 0263     y2 = y3 = y2 % 100;
	MOV  R26,R16
	CLR  R27
	RCALL SUBOPT_0xE
	RCALL __MODW21
	MOV  R19,R30
	MOV  R16,R30
; 0000 0264     y2 = y2 / 10 ;                                      //   (  10)
	MOV  R26,R16
	LDI  R27,0
	RCALL SUBOPT_0xF
	RCALL __DIVW21
	MOV  R16,R30
; 0000 0265     y3 = y3 % 10 ;                                      //   (    10)
	MOV  R26,R19
	CLR  R27
	RCALL SUBOPT_0xF
	RCALL __MODW21
	MOV  R19,R30
; 0000 0266     if (y1!=0)
	CPI  R17,0
	BREQ _0xCE
; 0000 0267         {
; 0000 0268         y1 = y1 + 0x30;
	SUBI R17,-LOW(48)
; 0000 0269         UDR = y1;                                       //       (2   3)
	OUT  0xC,R17
; 0000 026A         delay_ms(interval);
	RCALL SUBOPT_0x26
; 0000 026B         }
; 0000 026C     y2 = y2 + 0x30;
_0xCE:
	SUBI R16,-LOW(48)
; 0000 026D     y3 = y3 + 0x30;
	SUBI R19,-LOW(48)
; 0000 026E 
; 0000 026F     UDR = y2;                                           //       (2 )
	OUT  0xC,R16
; 0000 0270     delay_ms(interval);
	RCALL SUBOPT_0x26
; 0000 0271     UDR = y3;
	OUT  0xC,R19
; 0000 0272     delay_ms(interval);
	RCALL SUBOPT_0x26
; 0000 0273     UDR = ('\r');                                       //   ()
	RCALL SUBOPT_0x21
; 0000 0274     //delay_ms(500);
; 0000 0275 //-----------------------------------------------------------------------------------
; 0000 0276     delay_ms(1500);                                     //      SMS ( )
	RCALL SUBOPT_0x22
; 0000 0277 //===================================================================================
; 0000 0278     for (z=0;z<28;z++)                                  //   PUD SMS  
	RCALL SUBOPT_0x1B
_0xD0:
	RCALL SUBOPT_0x3A
	SBIW R26,28
	BRSH _0xD1
; 0000 0279         {
; 0000 027A         UDR = SMS_zag[z];
	RCALL SUBOPT_0x3B
	SUBI R30,LOW(-_SMS_zag)
	SBCI R31,HIGH(-_SMS_zag)
	RCALL SUBOPT_0x41
; 0000 027B         delay_ms(interval);
; 0000 027C         }
	RCALL SUBOPT_0x20
	RJMP _0xD0
_0xD1:
; 0000 027D     delay_ms(interval);
	RCALL SUBOPT_0x26
; 0000 027E     for (y1=0;y1<SMS_dlinna;y1++)                       //   PUD SMS  
	LDI  R17,LOW(0)
_0xD3:
	RCALL SUBOPT_0x2B
	CP   R17,R30
	BRSH _0xD4
; 0000 027F         {
; 0000 0280         UDR = SMS_text[y1];
	MOV  R30,R17
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x41
; 0000 0281         delay_ms(interval);
; 0000 0282         }
	SUBI R17,-1
	RJMP _0xD3
_0xD4:
; 0000 0283 
; 0000 0284     UDR = (26);                                         // ctrlZ->      0x1A
	LDI  R30,LOW(26)
	OUT  0xC,R30
; 0000 0285     delay_ms(1500);
	RCALL SUBOPT_0x22
; 0000 0286 
; 0000 0287     if (_flag==1)    PORTC.3 = 1;                       //     SMS     
	RCALL SUBOPT_0x32
	SBIW R26,1
	BRNE _0xD5
	SBI  0x15,3
; 0000 0288     else PORTC.3 = 0;
	RJMP _0xD8
_0xD5:
	CBI  0x15,3
; 0000 0289     }
_0xD8:
	RJMP _0x2020005
; .FEND
;//-------------------------------------------------------------
;//-------------  -------------------------------
;//-------------------------------------------------------------
;void Zvonok(void)
; 0000 028E     {  int r;
_Zvonok:
; .FSTART _Zvonok
; 0000 028F     PORTC.3 = 1;                                        //   SMS
	RCALL __SAVELOCR2
;	r -> R16,R17
	SBI  0x15,3
; 0000 0290     for(z=0;cmd_1[z]!='';z++)                           //     
	RCALL SUBOPT_0x1B
_0xDE:
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x1D
	BREQ _0xDF
; 0000 0291         {
; 0000 0292         UDR = cmd_1[z];
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x1E
; 0000 0293         delay_ms(interval);
	RCALL SUBOPT_0x26
; 0000 0294         }
	RCALL SUBOPT_0x20
	RJMP _0xDE
_0xDF:
; 0000 0295     UDR = ('\r');                                       //   ()
	RCALL SUBOPT_0x21
; 0000 0296     delay_ms(500);
	RCALL SUBOPT_0x12
; 0000 0297     for(z=0;cmd_2_1[z]!='';z++)                         //   
	RCALL SUBOPT_0x1B
_0xE1:
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x1D
	BREQ _0xE2
; 0000 0298         {
; 0000 0299         UDR = cmd_2_1[z];
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x1E
; 0000 029A         delay_ms(interval);
	RCALL SUBOPT_0x26
; 0000 029B         }
	RCALL SUBOPT_0x20
	RJMP _0xE1
_0xE2:
; 0000 029C     UDR = ('\r');                                       //   ()
	RCALL SUBOPT_0x21
; 0000 029D     delay_ms(500);
	RCALL SUBOPT_0x12
; 0000 029E 
; 0000 029F     for(z=0;cmd_10[z]!='';z++)                          //     
	RCALL SUBOPT_0x1B
_0xE4:
	RCALL SUBOPT_0x3B
	SUBI R30,LOW(-_cmd_10*2)
	SBCI R31,HIGH(-_cmd_10*2)
	RCALL SUBOPT_0x1D
	BREQ _0xE5
; 0000 02A0         {
; 0000 02A1         UDR = cmd_10[z];
	RCALL SUBOPT_0x3B
	SUBI R30,LOW(-_cmd_10*2)
	SBCI R31,HIGH(-_cmd_10*2)
	RCALL SUBOPT_0x1E
; 0000 02A2         delay_ms(interval);
	RCALL SUBOPT_0x26
; 0000 02A3         }
	RCALL SUBOPT_0x20
	RJMP _0xE4
_0xE5:
; 0000 02A4 
; 0000 02A5     for(z=0;cmd_8[z]!='';z++)                           //   
	RCALL SUBOPT_0x1B
_0xE7:
	RCALL SUBOPT_0x3D
	LD   R30,Z
	CPI  R30,0
	BREQ _0xE8
; 0000 02A6         {
; 0000 02A7         UDR = cmd_8[z];
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x41
; 0000 02A8         delay_ms(interval);
; 0000 02A9         }
	RCALL SUBOPT_0x20
	RJMP _0xE7
_0xE8:
; 0000 02AA     UDR = (';');
	LDI  R30,LOW(59)
	OUT  0xC,R30
; 0000 02AB     delay_ms(interval);
	RCALL SUBOPT_0x26
; 0000 02AC     UDR = ('\r');                                       //   ()
	RCALL SUBOPT_0x21
; 0000 02AD     delay_ms(1000);                                     //   ( )
	RCALL SUBOPT_0x17
; 0000 02AE 
; 0000 02AF     for (r=0;r<100;r++)
	RCALL SUBOPT_0x23
_0xEA:
	__CPWRN 16,17,100
	BRGE _0xEB
; 0000 02B0         {
; 0000 02B1         delay_ms (150);                                 //   15 
	LDI  R26,LOW(150)
	RCALL SUBOPT_0x42
; 0000 02B2         if (PINC.4==1)  {r=3000; _Err_out=1;}           //    -  
	SBIC 0x13,4
	RCALL SUBOPT_0x43
; 0000 02B3         if (PIND.3==1)  {r=3000; _Err_out=1;}           //    -  
	SBIC 0x10,3
	RCALL SUBOPT_0x43
; 0000 02B4         if (PIND.5==0)  {r=3000; _Err_out=1; _Blokir = 1;}  //     (  )
	SBIC 0x10,5
	RJMP _0xEE
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x44
; 0000 02B5         }
_0xEE:
	RCALL SUBOPT_0x24
	RJMP _0xEA
_0xEB:
; 0000 02B6 
; 0000 02B7     Otboy();                                            //   (  )
	RCALL _Otboy
; 0000 02B8 
; 0000 02B9     if (_flag==1)    PORTC.3 = 1;                       //     SMS     
	RCALL SUBOPT_0x32
	SBIW R26,1
	BRNE _0xEF
	SBI  0x15,3
; 0000 02BA     else PORTC.3 = 0;
	RJMP _0xF2
_0xEF:
	CBI  0x15,3
; 0000 02BB     }
_0xF2:
_0x2020006:
	LD   R16,Y+
	LD   R17,Y+
	RET
; .FEND
;//-------------------------------------------------------------
;//------------- --------------------------------
;//-------------------------------------------------------------
;void Zapusk(void)
; 0000 02C0     { unsigned int k; int t=0; int r=0;
_Zapusk:
; .FSTART _Zapusk
; 0000 02C1     _Err_out=0;                                         //  
	RCALL __SAVELOCR6
;	k -> R16,R17
;	t -> R18,R19
;	r -> R20,R21
	__GETWRN 18,19,0
	__GETWRN 20,21,0
	RCALL SUBOPT_0x45
; 0000 02C2     if (_Err<2) PORTB.0 = 1;                            //     2  
	RCALL SUBOPT_0x46
	BRGE _0xF5
	SBI  0x18,0
; 0000 02C3     for (t=0;t<20;t++)
_0xF5:
	__GETWRN 18,19,0
_0xF9:
	__CPWRN 18,19,20
	BRGE _0xFA
; 0000 02C4         {
; 0000 02C5         delay_ms (100);
	RCALL SUBOPT_0x1F
; 0000 02C6         if (PINC.4==1) {t=30; _Err_out=1;}
	SBIC 0x13,4
	RCALL SUBOPT_0x47
; 0000 02C7         if (PIND.3==1) {t=30; _Err_out=1;}
	SBIC 0x10,3
	RCALL SUBOPT_0x47
; 0000 02C8         }
	__ADDWRN 18,19,1
	RJMP _0xF9
_0xFA:
; 0000 02C9     if ((_Err<2)&&(_Err_out==0))
	RCALL SUBOPT_0x46
	BRGE _0xFE
	RCALL SUBOPT_0x48
	SBIW R26,0
	BREQ _0xFF
_0xFE:
	RJMP _0xFD
_0xFF:
; 0000 02CA       for (k=0;k<42000;k++)                             //  7   
	RCALL SUBOPT_0x23
_0x101:
	__CPWRN 16,17,-23536
	BRLO PC+2
	RJMP _0x102
; 0000 02CB         {
; 0000 02CC         #asm("wdr");                                    //   
	wdr
; 0000 02CD         if (_Err>1) {k=50000; _Err_out=1; _Blokir = 1;} //  2    -   
	RCALL SUBOPT_0x46
	BRLT _0x103
	RCALL SUBOPT_0x49
	RCALL SUBOPT_0x44
; 0000 02CE         if (PINC.4==1) {k=50000; _Err_out=1;}           //   -  
_0x103:
	SBIC 0x13,4
	RCALL SUBOPT_0x49
; 0000 02CF         if (PIND.3==1) {k=50000; _Err_out=1;}           //   -  
	SBIC 0x10,3
	RCALL SUBOPT_0x49
; 0000 02D0         if ((PIND.5==0)&&(_Err<2))                      //    -      2   ...
	SBIC 0x10,5
	RJMP _0x107
	RCALL SUBOPT_0x46
	BRLT _0x108
_0x107:
	RJMP _0x106
_0x108:
; 0000 02D1             { int f;
; 0000 02D2             r++;                                        //   
	SBIW R28,2
;	f -> Y+0
	__ADDWRN 20,21,1
; 0000 02D3             if (r>2) {k=50000; _Err_out=1;}             //     (  )-  2 
	__CPWRN 20,21,3
	BRLT _0x109
	RCALL SUBOPT_0x49
; 0000 02D4             for (f=0;f<402;f++)                         // 4   
_0x109:
	LDI  R30,LOW(0)
	STD  Y+0,R30
	STD  Y+0+1,R30
_0x10B:
	LD   R26,Y
	LDD  R27,Y+1
	CPI  R26,LOW(0x192)
	LDI  R30,HIGH(0x192)
	CPC  R27,R30
	BRLT PC+2
	RJMP _0x10C
; 0000 02D5                 {
; 0000 02D6                 if ((PIND.3==0)&&(PINC.4==0))           //    
	SBIC 0x10,3
	RJMP _0x10E
	SBIS 0x13,4
	RJMP _0x10F
_0x10E:
	RJMP _0x10D
_0x10F:
; 0000 02D7                     {
; 0000 02D8                     if (k<42000) PORTB.1 = 1;           //    7  (  )   
	__CPWRN 16,17,-23536
	BRSH _0x110
	SBI  0x18,1
; 0000 02D9                     else
	RJMP _0x113
_0x110:
; 0000 02DA                         {
; 0000 02DB                         PORTB.1 = 0;                    //  
	RCALL SUBOPT_0x4A
; 0000 02DC                         PORTB.0 = 0;                    //  
; 0000 02DD                         k=50000;                        //      7 
; 0000 02DE                         f=410;                          //       4 
; 0000 02DF                         }
_0x113:
; 0000 02E0                     }
; 0000 02E1                 else                                    //           ...
	RJMP _0x118
_0x10D:
; 0000 02E2                     {
; 0000 02E3                     PORTB.1 = 0;                        //  
	RCALL SUBOPT_0x4A
; 0000 02E4                     PORTB.0 = 0;                        //  
; 0000 02E5                     k=50000;                            //      7 
; 0000 02E6                     f=410;                              //       4 
; 0000 02E7                     }
_0x118:
; 0000 02E8                 if (f>400)
	LD   R26,Y
	LDD  R27,Y+1
	CPI  R26,LOW(0x191)
	LDI  R30,HIGH(0x191)
	CPC  R27,R30
	BRLT _0x11D
; 0000 02E9                     {
; 0000 02EA                     PORTB.1 = 0;                        //  
	CBI  0x18,1
; 0000 02EB                     _Err++;                             //     -  
	LDI  R26,LOW(__Err)
	LDI  R27,HIGH(__Err)
	RCALL SUBOPT_0x1
; 0000 02EC                     if (_Err>1) f=410;                  //   2 (  )   
	RCALL SUBOPT_0x46
	BRLT _0x120
	RCALL SUBOPT_0x4B
; 0000 02ED                     else f=0;
	RJMP _0x121
_0x120:
	LDI  R30,LOW(0)
	STD  Y+0,R30
	STD  Y+0+1,R30
; 0000 02EE                     for (t=0;t<60;t++)
_0x121:
	__GETWRN 18,19,0
_0x123:
	__CPWRN 18,19,60
	BRGE _0x124
; 0000 02EF                         {
; 0000 02F0                         delay_ms (100);                 //    6 
	RCALL SUBOPT_0x1F
; 0000 02F1                         if (PINC.4==1) {t=70; _Err_out=1;}  //  
	SBIC 0x13,4
	RCALL SUBOPT_0x4C
; 0000 02F2                         if (PIND.3==1) {t=70; _Err_out=1;}  //   
	SBIC 0x10,3
	RCALL SUBOPT_0x4C
; 0000 02F3                         if (Ring==4)                    //   
	RCALL SUBOPT_0x3
	SBIW R26,4
	BRNE _0x127
; 0000 02F4                             {
; 0000 02F5                             Ring=0;                     //   
	RCALL SUBOPT_0x6
; 0000 02F6                             _Tel = AON_();              //      
	RCALL SUBOPT_0x4D
; 0000 02F7                             Otboy();                    //   ( )
; 0000 02F8                             if (_Tel==1)
	BRNE _0x128
; 0000 02F9                                 {
; 0000 02FA                                 t=70;
	RCALL SUBOPT_0x4C
; 0000 02FB                                 _Err_out=1;
; 0000 02FC                                 }
; 0000 02FD                             }
_0x128:
; 0000 02FE                         }
_0x127:
	__ADDWRN 18,19,1
	RJMP _0x123
_0x124:
; 0000 02FF                     }
; 0000 0300                 if (PIND.5==1)                          //   ,  () 
_0x11D:
	SBIS 0x10,5
	RJMP _0x129
; 0000 0301                   {
; 0000 0302                     f=410;
	RCALL SUBOPT_0x4B
; 0000 0303                     PORTB.1 = 0;                        //  
	CBI  0x18,1
; 0000 0304                     _Err_out = 0;                       //   -   
	RCALL SUBOPT_0x45
; 0000 0305                     _Err = 0;                           //   -  -   
	RCALL SUBOPT_0x4E
; 0000 0306 
; 0000 0307                     if (_Tel_SMS==0) sms_out();         //  SMS ( )
	LDS  R30,__Tel_SMS
	CPI  R30,0
	BRNE _0x12C
	RCALL _sms_out
; 0000 0308                     else Zvonok();                      //    15  ( )
	RJMP _0x12D
_0x12C:
	RCALL _Zvonok
; 0000 0309                     Temperat = 0;
_0x12D:
	RCALL SUBOPT_0x4F
; 0000 030A                     if (_Err_out>0)
	RCALL SUBOPT_0x48
	RCALL __CPW02
	BRGE _0x12E
; 0000 030B                         {
; 0000 030C                         k=50000;                        //     (   )  _Err++ ...
	__GETWRN 16,17,-15536
; 0000 030D                         _Err_out = 0;
	RCALL SUBOPT_0x45
; 0000 030E                         }                               //   -   
; 0000 030F                     else
	RJMP _0x12F
_0x12E:
; 0000 0310                         {
; 0000 0311                         _Err = 0;
	RCALL SUBOPT_0x4E
; 0000 0312                        // Temperat = 0;
; 0000 0313                         PORTB.2 = 1;                    //  
	SBI  0x18,2
; 0000 0314                         delay_ms (500);
	RCALL SUBOPT_0x12
; 0000 0315                         PORTB.2 = 0;
	CBI  0x18,2
; 0000 0316                         delay_ms (500);
	RCALL SUBOPT_0x12
; 0000 0317                         PORTB.2 = 1;
	SBI  0x18,2
; 0000 0318                         delay_ms (500);
	RCALL SUBOPT_0x12
; 0000 0319                         PORTB.2 = 0;
	CBI  0x18,2
; 0000 031A                         }
_0x12F:
; 0000 031B                   }
; 0000 031C                 delay_ms (10);
_0x129:
	LDI  R26,LOW(10)
	RCALL SUBOPT_0x42
; 0000 031D                 }
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	ST   Y,R30
	STD  Y+1,R31
	RJMP _0x10B
_0x10C:
; 0000 031E             }
	ADIW R28,2
; 0000 031F         if (Ring==4)                                    // ----   ( ) ----
_0x106:
	RCALL SUBOPT_0x3
	SBIW R26,4
	BRNE _0x138
; 0000 0320                 {
; 0000 0321                 Ring=0;                                 //   
	RCALL SUBOPT_0x6
; 0000 0322                 _Tel = AON_();                          //      
	RCALL SUBOPT_0x4D
; 0000 0323                 Otboy();                                //   ( )
; 0000 0324                 if (_Tel==1)
	BRNE _0x139
; 0000 0325                     {
; 0000 0326                     _Err_out=1;
	RCALL SUBOPT_0x4
	STS  __Err_out,R30
	STS  __Err_out+1,R31
; 0000 0327                     k=50000;
	__GETWRN 16,17,-15536
; 0000 0328 
; 0000 0329                     delay_ms (500);                     //   
	RCALL SUBOPT_0x12
; 0000 032A                     }
; 0000 032B                 }
_0x139:
; 0000 032C         delay_ms (10);
_0x138:
	LDI  R26,LOW(10)
	RCALL SUBOPT_0x42
; 0000 032D         }
	RCALL SUBOPT_0x24
	RJMP _0x101
_0x102:
; 0000 032E     PORTB.0 = 0;                                        //  
_0xFD:
	CBI  0x18,0
; 0000 032F     PORTB.1 = 0;                                        //      
	CBI  0x18,1
; 0000 0330     PORTC= (1<<PORTC5) | (1<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0); // Led -   ...
	LDI  R30,LOW(48)
	OUT  0x15,R30
; 0000 0331  //   PORTC.4 = 0;
; 0000 0332     Temperat=0;                                         //    
	RCALL SUBOPT_0x4F
; 0000 0333 //    #asm("sei")                                       //  
; 0000 0334     }
	RCALL __LOADLOCR6
	RJMP _0x2020004
; .FEND
;//-------------------------------------------------------------------------------------
;//----      (   5   5 ) ----
;//-------------------------------------------------------------------------------------
;void Priviazka_tel(void)                                //      (   5  ...
; 0000 0339     {  char Ring2, y, x =0;
_Priviazka_tel:
; .FSTART _Priviazka_tel
; 0000 033A     if (cmd_8e[0]=='+')                                 //     (    +)   SMS ...
	RCALL __SAVELOCR4
;	Ring2 -> R17
;	y -> R16
;	x -> R19
	LDI  R19,0
	LDI  R26,LOW(_cmd_8e)
	LDI  R27,HIGH(_cmd_8e)
	RCALL __EEPROMRDB
	CPI  R30,LOW(0x2B)
	BRNE _0x13E
; 0000 033B         {
; 0000 033C         _flag = 3;                                      //  SMS "Clear Tel"
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RCALL SUBOPT_0x50
; 0000 033D         sms_out();                                      //  SMS   
	RCALL _sms_out
; 0000 033E        cmd_8[0]=cmd_8e[0]=0;                            //  +    (  )
	LDI  R26,LOW(_cmd_8e)
	LDI  R27,HIGH(_cmd_8e)
	LDI  R30,LOW(0)
	RCALL __EEPROMWRB
	STS  _cmd_8,R30
; 0000 033F         }
; 0000 0340     PORTC.2 = 1;                                        // Led    
_0x13E:
	SBI  0x15,2
; 0000 0341     if (Ring==4)                                        //  
	RCALL SUBOPT_0x3
	SBIW R26,4
	BREQ PC+2
	RJMP _0x141
; 0000 0342         {
; 0000 0343         PORTC.1 = 1;                                    // Led    
	SBI  0x15,1
; 0000 0344         delay_ms (1000);
	RCALL SUBOPT_0x17
; 0000 0345         Ring=0;                                         //   
	RCALL SUBOPT_0x6
; 0000 0346         Otboy();                                        //  
	RCALL _Otboy
; 0000 0347         if (i==0) return;                               //     - 
	LDS  R30,_i
	CPI  R30,0
	BRNE _0x144
	RJMP _0x2020005
; 0000 0348         x=i;
_0x144:
	LDS  R19,_i
; 0000 0349         #asm("cli")                                     //  
	cli
; 0000 034A         i = 0;                                          //   UART 
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xB
; 0000 034B 
; 0000 034C         for ( rx_cursor=0;rx_cursor!=x;rx_cursor++)
	RCALL SUBOPT_0x16
_0x146:
	LDS  R26,_rx_cursor
	CP   R19,R26
	BRNE PC+2
	RJMP _0x147
; 0000 034D             { PORTC.2 = 1;
	SBI  0x15,2
; 0000 034E             y = MyBuffer[rx_cursor];
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0xA
	LD   R16,Z
; 0000 034F             if (y=='R') Ring2=1;
	CPI  R16,82
	BRNE _0x14A
	LDI  R17,LOW(1)
; 0000 0350             if (y=='I')
_0x14A:
	CPI  R16,73
	BRNE _0x14B
; 0000 0351                 {
; 0000 0352                 if (Ring2==1) Ring2++;
	CPI  R17,1
	BRNE _0x14C
	SUBI R17,-1
; 0000 0353                 else  Ring2=0;
	RJMP _0x14D
_0x14C:
	LDI  R17,LOW(0)
; 0000 0354                 }
_0x14D:
; 0000 0355             if (y=='N')
_0x14B:
	CPI  R16,78
	BRNE _0x14E
; 0000 0356                 {
; 0000 0357                 if (Ring2==2) Ring2++;
	CPI  R17,2
	BRNE _0x14F
	SUBI R17,-1
; 0000 0358                 else  Ring2=0;
	RJMP _0x150
_0x14F:
	LDI  R17,LOW(0)
; 0000 0359                 }
_0x150:
; 0000 035A             if (y=='G')
_0x14E:
	CPI  R16,71
	BRNE _0x151
; 0000 035B                 {
; 0000 035C                 if (Ring2==3) Ring2++;                  // Ring = 4   
	CPI  R17,3
	BRNE _0x152
	SUBI R17,-1
; 0000 035D                 else  Ring2=0;
	RJMP _0x153
_0x152:
	LDI  R17,LOW(0)
; 0000 035E                 }
_0x153:
; 0000 035F             if (Ring2==4)
_0x151:
	CPI  R17,4
	BRNE _0x154
; 0000 0360                 {
; 0000 0361                 rx_cursor=rx_cursor+13;                 //  RING   13      ...
	RCALL SUBOPT_0x19
	SUBI R30,-LOW(13)
	STS  _rx_cursor,R30
; 0000 0362                 for (z=0;z<13;z++)
	RCALL SUBOPT_0x1B
_0x156:
	RCALL SUBOPT_0x3A
	SBIW R26,13
	BRSH _0x157
; 0000 0363                     {
; 0000 0364                     cmd_8[z] = cmd_8e[z] = MyBuffer[rx_cursor]; //       EEProm   ...
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x51
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0xA
	LD   R30,Z
	RCALL __EEPROMWRB
	MOVW R26,R0
	ST   X,R30
; 0000 0365                     rx_cursor++;
	RCALL SUBOPT_0x1A
; 0000 0366                     if (z==12)
	RCALL SUBOPT_0x3A
	SBIW R26,12
	BRNE _0x158
; 0000 0367                         {
; 0000 0368                         cmd_8[z] = cmd_8e[z] = 0;
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x51
	LDI  R30,LOW(0)
	RCALL __EEPROMWRB
	MOVW R26,R0
	ST   X,R30
; 0000 0369                         _flag = 4;                      //  SMS "New Tel"
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL SUBOPT_0x50
; 0000 036A                         delay_ms (interval);
	RCALL SUBOPT_0x26
; 0000 036B                         sms_out();                      //  SMS   
	RCALL _sms_out
; 0000 036C                         PORTC.3 = 1;                    // Led    
	SBI  0x15,3
; 0000 036D                         delay_ms (500);
	RCALL SUBOPT_0x12
; 0000 036E                         PORTC=(1<<PORTC5) | (1<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);
	LDI  R30,LOW(48)
	OUT  0x15,R30
; 0000 036F                         #asm("sei")                     //  
	sei
; 0000 0370                         return;                         //    
	RJMP _0x2020005
; 0000 0371                         }
; 0000 0372                     }
_0x158:
	RCALL SUBOPT_0x20
	RJMP _0x156
_0x157:
; 0000 0373                 }
; 0000 0374             }
_0x154:
	RCALL SUBOPT_0x1A
	RJMP _0x146
_0x147:
; 0000 0375         }
; 0000 0376     }
_0x141:
_0x2020005:
	RCALL __LOADLOCR4
	ADIW R28,4
	RET
; .FEND
;
;//=====================================================================
;void main(void)
; 0000 037A {
_main:
; .FSTART _main
; 0000 037B // Declare your local variables here
; 0000 037C //-----------------------
; 0000 037D // Watchdog Timer initialization
; 0000 037E // Watchdog Timer Prescaler: OSC/2048k
; 0000 037F #pragma optsize-
; 0000 0380 //WDTCR=0x1F;                // OSC/2048k
; 0000 0381 //WDTCR=0x0F;                // 1   2 
; 0000 0382 WDTCR = (1<<WDCE) | (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (1<<WDP0);   // OSC/2048k
	LDI  R30,LOW(31)
	OUT  0x21,R30
; 0000 0383 WDTCR = (0<<WDCE) | (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (1<<WDP0);   // 1   2 
	LDI  R30,LOW(15)
	OUT  0x21,R30
; 0000 0384 
; 0000 0385 // WDTCR = (1<<WDCE) | (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (0<<WDP0);   // OSC/1024k
; 0000 0386 // WDTCR = (0<<WDCE) | (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (0<<WDP0);   // 1   1 
; 0000 0387 
; 0000 0388 //-----------------------
; 0000 0389 // Input/Output Ports initialization
; 0000 038A // Port B initialization
; 0000 038B // Function: Bit7=In Bit6=In Bit5=Out Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=Out
; 0000 038C DDRB=(0<<DDB7) | (0<<DDB6) | (1<<DDB5) | (1<<DDB4) | (1<<DDB3) | (1<<DDB2) | (1<<DDB1) | (1<<DDB0);
	LDI  R30,LOW(63)
	OUT  0x17,R30
; 0000 038D // State: Bit7=T Bit6=T Bit5=0 Bit4=0 Bit3=0 Bit2=0 Bit1=0 Bit0=0
; 0000 038E PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 038F 
; 0000 0390 // Port C initialization
; 0000 0391 // Function: Bit6=In Bit5=In Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=In
; 0000 0392 DDRC=(0<<DDC6) | (0<<DDC5) | (0<<DDC4) | (1<<DDC3) | (1<<DDC2) | (1<<DDC1) | (0<<DDC0);
	LDI  R30,LOW(14)
	OUT  0x14,R30
; 0000 0393 // State: Bit6=T Bit5=T Bit4=0 Bit3=0 Bit2=0 Bit1=0 Bit0=T
; 0000 0394 PORTC=(0<<PORTC6) | (1<<PORTC5) | (1<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);
	LDI  R30,LOW(48)
	OUT  0x15,R30
; 0000 0395 
; 0000 0396 // Port D initialization
; 0000 0397 // Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In
; 0000 0398 DDRD=(0<<DDD7) | (0<<DDD6) | (0<<DDD5) | (0<<DDD4) | (0<<DDD3) | (0<<DDD2) | (0<<DDD1) | (0<<DDD0);
	LDI  R30,LOW(0)
	OUT  0x11,R30
; 0000 0399 // State: Bit7=T Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T
; 0000 039A PORTD=(0<<PORTD7) | (0<<PORTD6) | (1<<PORTD5) | (1<<PORTD4) | (1<<PORTD3) | (1<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);
	LDI  R30,LOW(60)
	OUT  0x12,R30
; 0000 039B //------------------------------
; 0000 039C // Timer/Counter 0 initialization
; 0000 039D // Clock source: System Clock
; 0000 039E // Clock value: Timer 0 Stopped
; 0000 039F TCCR0=(0<<CS02) | (0<<CS01) | (0<<CS00);
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 03A0 TCNT0=0x00;
	OUT  0x32,R30
; 0000 03A1 
; 0000 03A2 // Timer/Counter 1 initialization
; 0000 03A3 // Clock source: System Clock
; 0000 03A4 // Clock value: 3,906 kHz
; 0000 03A5 // Mode: Normal top=0xFFFF
; 0000 03A6 // OC1A output: Discon.
; 0000 03A7 // OC1B output: Discon.
; 0000 03A8 // Noise Canceler: Off
; 0000 03A9 // Input Capture on Falling Edge
; 0000 03AA // Timer1 Overflow Interrupt: On
; 0000 03AB // Input Capture Interrupt: Off
; 0000 03AC // Compare A Match Interrupt: Off
; 0000 03AD // Compare B Match Interrupt: Off
; 0000 03AE TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 03AF TCCR1B=0x05;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
; 0000 03B0 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 03B1 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 03B2 ICR1H=0x00;
	OUT  0x27,R30
; 0000 03B3 ICR1L=0x00;
	OUT  0x26,R30
; 0000 03B4 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 03B5 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 03B6 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 03B7 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 03B8 
; 0000 03B9 // Timer/Counter 2 initialization
; 0000 03BA // Clock source: System Clock
; 0000 03BB // Clock value: Timer2 Stopped
; 0000 03BC // Mode: Normal top=0xFF
; 0000 03BD // OC2 output: Disconnected
; 0000 03BE ASSR=0<<AS2;
	OUT  0x22,R30
; 0000 03BF TCCR2=(0<<PWM2) | (0<<COM21) | (0<<COM20) | (0<<CTC2) | (0<<CS22) | (0<<CS21) | (0<<CS20);
	OUT  0x25,R30
; 0000 03C0 TCNT2=0x00;
	OUT  0x24,R30
; 0000 03C1 OCR2=0x00;
	OUT  0x23,R30
; 0000 03C2 
; 0000 03C3 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 03C4 //TIMSK=(0<<OCIE2) | (0<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (0<<TOIE1) | (0<<TOIE0);
; 0000 03C5 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 03C6 TIMSK=0x04;
	LDI  R30,LOW(4)
	OUT  0x39,R30
; 0000 03C7 //----------------------------------------
; 0000 03C8 // External Interrupt(s) initialization
; 0000 03C9 // INT0: Off
; 0000 03CA // INT1: Off
; 0000 03CB MCUCR=(0<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);
	LDI  R30,LOW(0)
	OUT  0x35,R30
; 0000 03CC //----------------------------------------
; 0000 03CD // USART initialization
; 0000 03CE // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 03CF // USART Receiver: On
; 0000 03D0 // USART Transmitter: On
; 0000 03D1 // USART Mode: Asynchronous
; 0000 03D2 // USART Baud Rate: 9600
; 0000 03D3 //UCSRA=0x00;
; 0000 03D4 //UCSRB=0x98;  //0x08;                                  //        0x98; // ( )   ...
; 0000 03D5 //UCSRB=(0<<RXEN)|( 1<<TXEN);                           //      USART
; 0000 03D6 //UCSRC=0x86;                                           //    AtMega8
; 0000 03D7 //UBRRH=0x00;
; 0000 03D8 //UBRRL=0x19;
; 0000 03D9 
; 0000 03DA // USART initialization
; 0000 03DB // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 03DC // USART Receiver: On
; 0000 03DD // USART Transmitter: On
; 0000 03DE // USART Mode: Asynchronous
; 0000 03DF // USART Baud Rate: 9600
; 0000 03E0 
; 0000 03E1 UCSRA=0x00;
	OUT  0xB,R30
; 0000 03E2 UCSRB=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
; 0000 03E3 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
; 0000 03E4 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 03E5 UBRRL=0x19;
	LDI  R30,LOW(25)
	OUT  0x9,R30
; 0000 03E6 //----------------------
; 0000 03E7 // Analog Comparator initialization
; 0000 03E8 // Analog Comparator: On
; 0000 03E9 // The Analog Comparator's positive input is
; 0000 03EA // connected to the AIN0 pin
; 0000 03EB // The Analog Comparator's negative input is
; 0000 03EC // connected to the AIN1 pin
; 0000 03ED // Interrupt on Rising Output Edge
; 0000 03EE // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 03EF ACSR=(0<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (1<<ACIE) | (0<<ACIC) | (1<<ACIS1) | (1<<ACIS0);
	LDI  R30,LOW(11)
	OUT  0x8,R30
; 0000 03F0 SFIOR=(0<<ACME);
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 03F1 
; 0000 03F2 // ADC initialization
; 0000 03F3 // ADC disabled
; 0000 03F4 ADCSRA=(0<<ADEN) | (0<<ADSC) | (0<<ADFR) | (0<<ADIF) | (0<<ADIE) | (0<<ADPS2) | (0<<ADPS1) | (0<<ADPS0);
	OUT  0x6,R30
; 0000 03F5 //----------------------------------------
; 0000 03F6 // SPI initialization
; 0000 03F7 // SPI disabled
; 0000 03F8 SPCR=(0<<SPIE) | (0<<SPE) | (0<<DORD) | (0<<MSTR) | (0<<CPOL) | (0<<CPHA) | (0<<SPR1) | (0<<SPR0);
	OUT  0xD,R30
; 0000 03F9 //----------------------------------------
; 0000 03FA // TWI initialization
; 0000 03FB // TWI disabled
; 0000 03FC TWCR=(0<<TWEA) | (0<<TWSTA) | (0<<TWSTO) | (0<<TWEN) | (0<<TWIE);
	OUT  0x36,R30
; 0000 03FD //========================================
; 0000 03FE if (devices==0)
	TST  R5
	BRNE _0x15B
; 0000 03FF         {
; 0000 0400         devices=w1_search(DS18B20_SEARCH_ROM_CMD,rom_code); //        1-Wire
	LDI  R30,LOW(240)
	ST   -Y,R30
	LDI  R26,LOW(_rom_code)
	LDI  R27,HIGH(_rom_code)
	RCALL _w1_search
	MOV  R5,R30
; 0000 0401         ds18b20_init(0,-35,35,DS18B20_12BIT_RES);       //    12  
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(221)
	ST   -Y,R30
	LDI  R30,LOW(35)
	ST   -Y,R30
	LDI  R26,LOW(3)
	RCALL _ds18b20_init
; 0000 0402         delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RCALL _delay_ms
; 0000 0403         }
; 0000 0404 _Start_telef();
_0x15B:
	RCALL __Start_telef
; 0000 0405 #asm("cli")                                             //  
	cli
; 0000 0406 i = 0;                                                  //   UART 
	LDI  R30,LOW(0)
	STS  _i,R30
; 0000 0407 #asm("sei")                                             //  
	sei
; 0000 0408 if (cmd_8e[0]!='+') Priviazka_tel();                    //      (     +)
	LDI  R26,LOW(_cmd_8e)
	LDI  R27,HIGH(_cmd_8e)
	RCALL __EEPROMRDB
	CPI  R30,LOW(0x2B)
	BREQ _0x15C
	RCALL _Priviazka_tel
; 0000 0409 for(z=0;z<13;z++)                                       //     EEProm
_0x15C:
	LDI  R30,LOW(0)
	STS  _z,R30
	STS  _z+1,R30
_0x15E:
	LDS  R26,_z
	LDS  R27,_z+1
	SBIW R26,13
	BRSH _0x15F
; 0000 040A         {
; 0000 040B         cmd_8[z] = cmd_8e[z];                           //     EEProm  
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_8)
	SBCI R31,HIGH(-_cmd_8)
	MOVW R0,R30
	LDS  R26,_z
	LDS  R27,_z+1
	SUBI R26,LOW(-_cmd_8e)
	SBCI R27,HIGH(-_cmd_8e)
	RCALL __EEPROMRDB
	MOVW R26,R0
	ST   X,R30
; 0000 040C         }
	LDI  R26,LOW(_z)
	LDI  R27,HIGH(_z)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RJMP _0x15E
_0x15F:
; 0000 040D _Tel_SMS = _Tel_SMS_E;                                  //     SMS  
	LDI  R26,LOW(__Tel_SMS_E)
	LDI  R27,HIGH(__Tel_SMS_E)
	RCALL __EEPROMRDB
	STS  __Tel_SMS,R30
; 0000 040E if (_Tel_SMS>1) _Tel_SMS_E=_Tel_SMS=0;                  //   0  1
	LDS  R26,__Tel_SMS
	CPI  R26,LOW(0x2)
	BRLO _0x160
	LDI  R30,LOW(0)
	STS  __Tel_SMS,R30
	LDI  R26,LOW(__Tel_SMS_E)
	LDI  R27,HIGH(__Tel_SMS_E)
	RCALL __EEPROMWRB
; 0000 040F 
; 0000 0410 //----------------------------------------------
; 0000 0411 // Global enable interrupts
; 0000 0412 #asm("sei")
_0x160:
	sei
; 0000 0413 PORTD.2 = 0;
	CBI  0x12,2
; 0000 0414 //===============================================================================================
; 0000 0415 while (1)  //   
_0x163:
; 0000 0416    {   int t1,t2,t3,t4=0;
; 0000 0417    _Err = 0;                                            //   
	SBIW R28,8
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
;	t1 -> Y+6
;	t2 -> Y+4
;	t3 -> Y+2
;	t4 -> Y+0
	STS  __Err,R30
	STS  __Err+1,R30
; 0000 0418 //-----------------------      -----------------
; 0000 0419    if (PIND.5==1)                                       //   
	SBIS 0x10,5
	RJMP _0x166
; 0000 041A      {
; 0000 041B      #asm("cli")
	cli
; 0000 041C 
; 0000 041D      for (;PIND.5==1;)                                  //       
_0x168:
	SBIS 0x10,5
	RJMP _0x169
; 0000 041E         {
; 0000 041F         #asm("wdr");                                    //   
	wdr
; 0000 0420 
; 0000 0421 
; 0000 0422         PORTB.0 = 0;                                    //      (      ...
	CBI  0x18,0
; 0000 0423         PORTB.1 = 0;                                    //      
	CBI  0x18,1
; 0000 0424         if (PINC.4==1)  PORTB.2 = 1;                    //         
	SBIS 0x13,4
	RJMP _0x16E
	SBI  0x18,2
; 0000 0425         else            PORTB.2 = 0;                    //   
	RJMP _0x171
_0x16E:
	CBI  0x18,2
; 0000 0426         if ((PIND.3==1)&(PINC.0==1))                    // = Drive      
_0x171:
	LDI  R26,0
	SBIC 0x10,3
	LDI  R26,1
	LDI  R30,LOW(1)
	RCALL __EQB12
	MOV  R0,R30
	LDI  R26,0
	SBIC 0x13,0
	LDI  R26,1
	LDI  R30,LOW(1)
	RCALL __EQB12
	AND  R30,R0
	BREQ _0x174
; 0000 0427             {
; 0000 0428             PORTC.2 = 1;
	SBI  0x15,2
; 0000 0429             for (;PINC.0==1;) delay_ms (100);           //  
_0x178:
	SBIS 0x13,0
	RJMP _0x179
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	RJMP _0x178
_0x179:
; 0000 042A for (i=0;i<100;i++)
	LDI  R30,LOW(0)
	STS  _i,R30
_0x17B:
	LDS  R26,_i
	CPI  R26,LOW(0x64)
	BRSH _0x17C
; 0000 042B                 {
; 0000 042C 
; 0000 042D                 if (PINC.0==1)
	SBIS 0x13,0
	RJMP _0x17D
; 0000 042E                     {
; 0000 042F                     if (_Tel_SMS==0) _Tel_SMS_E=_Tel_SMS=1; //     SMS=0  =1
	LDS  R30,__Tel_SMS
	CPI  R30,0
	BRNE _0x17E
	LDI  R30,LOW(1)
	RJMP _0x1CC
; 0000 0430                     else             _Tel_SMS_E=_Tel_SMS=0;
_0x17E:
	LDI  R30,LOW(0)
_0x1CC:
	STS  __Tel_SMS,R30
	LDI  R26,LOW(__Tel_SMS_E)
	LDI  R27,HIGH(__Tel_SMS_E)
	RCALL __EEPROMWRB
; 0000 0431                     i=65;
	LDI  R30,LOW(65)
	STS  _i,R30
; 0000 0432                     }
; 0000 0433                 delay_ms (50);
_0x17D:
	LDI  R26,LOW(50)
	LDI  R27,0
	RCALL _delay_ms
; 0000 0434                 }
	LDS  R30,_i
	SUBI R30,-LOW(1)
	STS  _i,R30
	RJMP _0x17B
_0x17C:
; 0000 0435            PORTC.2 = 0;
	CBI  0x15,2
; 0000 0436            #asm("sei")
	sei
; 0000 0437            _Start_telef();                              //          Si ...
	RCALL __Start_telef
; 0000 0438            #asm("cli")
	cli
; 0000 0439            }
; 0000 043A         }
_0x174:
	RJMP _0x168
_0x169:
; 0000 043B         _Blokir = 0;                                    //      
	LDI  R30,LOW(0)
	STS  __Blokir,R30
	STS  __Blokir+1,R30
; 0000 043C         Temperat = 0;                                   //     (  )
	STS  _Temperat,R30
	STS  _Temperat+1,R30
; 0000 043D       }
; 0000 043E       //-----------------------------------------------------
; 0000 043F    else {
	RJMP _0x182
_0x166:
; 0000 0440         #asm("sei")                                     //    (  )
	sei
; 0000 0441         PORTB.2 = 0;                                    //  
	CBI  0x18,2
; 0000 0442 //---------- ------------------------------------
; 0000 0443    if (PIND.3==1)                                       //          -     ...
	SBIS 0x10,3
	RJMP _0x185
; 0000 0444      {
; 0000 0445      if (cmd_8[0]!='+')  Priviazka_tel();               //           +
	LDS  R26,_cmd_8
	CPI  R26,LOW(0x2B)
	BREQ _0x186
	RCALL _Priviazka_tel
; 0000 0446         if (PINC.4==0)
_0x186:
	SBIC 0x13,4
	RJMP _0x187
; 0000 0447             {                                           //    5    5      ...
; 0000 0448             for (t1=0;t1<5;t1++)
	LDI  R30,LOW(0)
	STD  Y+6,R30
	STD  Y+6+1,R30
_0x189:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,5
	BRGE _0x18A
; 0000 0449                 {
; 0000 044A                 for (t2=0;t2<40;t2++)
	LDI  R30,LOW(0)
	STD  Y+4,R30
	STD  Y+4+1,R30
_0x18C:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,40
	BRGE _0x18D
; 0000 044B                     {
; 0000 044C                     if (PINC.4==0) delay_ms (25);
	SBIC 0x13,4
	RJMP _0x18E
	LDI  R26,LOW(25)
	LDI  R27,0
	RCALL _delay_ms
; 0000 044D                     else
	RJMP _0x18F
_0x18E:
; 0000 044E                         {
; 0000 044F                         for (t3=0;t3<40;t3++)
	LDI  R30,LOW(0)
	STD  Y+2,R30
	STD  Y+2+1,R30
_0x191:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,40
	BRGE _0x192
; 0000 0450                             {
; 0000 0451                             if (PINC.4==1) delay_ms (25);
	SBIS 0x13,4
	RJMP _0x193
	LDI  R26,LOW(25)
	LDI  R27,0
	RCALL _delay_ms
; 0000 0452                             else
	RJMP _0x194
_0x193:
; 0000 0453                                 {
; 0000 0454                                 t4++;
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	ST   Y,R30
	STD  Y+1,R31
; 0000 0455                                 t3=t2=41;
	LDI  R30,LOW(41)
	LDI  R31,HIGH(41)
	STD  Y+4,R30
	STD  Y+4+1,R31
	STD  Y+2,R30
	STD  Y+2+1,R31
; 0000 0456 
; 0000 0457                                 }
_0x194:
; 0000 0458                             }
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	RJMP _0x191
_0x192:
; 0000 0459                         }
_0x18F:
; 0000 045A                     }
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
	RJMP _0x18C
_0x18D:
; 0000 045B                 }
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x189
_0x18A:
; 0000 045C             if (t4>4) Priviazka_tel();                  //      (   5  ...
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,5
	BRLT _0x195
	RCALL _Priviazka_tel
; 0000 045D             }
_0x195:
; 0000 045E      }
_0x187:
; 0000 045F    //------------------------------------------------------
; 0000 0460         delay_ms (500);
_0x185:
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RCALL _delay_ms
; 0000 0461         if ((PINC.4==0)&&(PIND.3==0))                   // ====        ====
	SBIC 0x13,4
	RJMP _0x197
	SBIS 0x10,3
	RJMP _0x198
_0x197:
	RJMP _0x196
_0x198:
; 0000 0462             {                                           //   :
; 0000 0463 //-------------    ----------------------------
; 0000 0464 //            if (PIND.4==1)
; 0000 0465             if (_tim > _tim_end)                       //    DS18b20   60 
	LDS  R26,__tim
	LDS  R27,__tim+1
	SBIW R26,61
	BRLT _0x199
; 0000 0466                 {
; 0000 0467                 _tim = 0;
	LDI  R30,LOW(0)
	STS  __tim,R30
	STS  __tim+1,R30
; 0000 0468                 PORTC.1 = 1;
	SBI  0x15,1
; 0000 0469                 _Temper();
	RCALL __Temper
; 0000 046A                 PORTC.1 = 0;
	CBI  0x15,1
; 0000 046B                 }
; 0000 046C             if (Temperat==1)
_0x199:
	LDS  R26,_Temperat
	LDS  R27,_Temperat+1
	SBIW R26,1
	BRNE _0x19E
; 0000 046D                 {                                       // ----   -17   ----
; 0000 046E                 if (_Blokir==0)
	LDS  R30,__Blokir
	LDS  R31,__Blokir+1
	SBIW R30,0
	BRNE _0x19F
; 0000 046F                         {
; 0000 0470                         _flag = 0;                      //  SMS "Temperat"
	LDI  R30,LOW(0)
	STS  __flag,R30
	STS  __flag+1,R30
; 0000 0471                         PORTC.1 = 1;                    // Led   
	SBI  0x15,1
; 0000 0472                         Zapusk();
	RCALL _Zapusk
; 0000 0473                         PORTC.1 = 0;
	CBI  0x15,1
; 0000 0474                         }
; 0000 0475                 }
_0x19F:
; 0000 0476 //-------------    ----------------------------
; 0000 0477             if (Deact==5)                               //     -   "DEACT"
_0x19E:
	LDS  R26,_Deact
	LDS  R27,_Deact+1
	SBIW R26,5
	BRNE _0x1A4
; 0000 0478                 {
; 0000 0479                 Deact=0;
	LDI  R30,LOW(0)
	STS  _Deact,R30
	STS  _Deact+1,R30
; 0000 047A                 _Start_telef();                         //  Deact==5( )    GPS  ...
	RCALL __Start_telef
; 0000 047B                 }
; 0000 047C             if (Ring==4)                                //  Ring==4( )   ()
_0x1A4:
	LDS  R26,_Ring
	LDS  R27,_Ring+1
	SBIW R26,4
	BRNE _0x1A5
; 0000 047D                 {
; 0000 047E                 Ring=0;                                 //   
	LDI  R30,LOW(0)
	STS  _Ring,R30
	STS  _Ring+1,R30
; 0000 047F                 if(_Blokir==0)                          // ----      ( ) --- ...
	LDS  R30,__Blokir
	LDS  R31,__Blokir+1
	SBIW R30,0
	BRNE _0x1A6
; 0000 0480                     {
; 0000 0481                     _Tel = 0;
	LDI  R30,LOW(0)
	STS  __Tel,R30
	STS  __Tel+1,R30
; 0000 0482                     _Tel = AON_();                      //      
	RCALL _AON_
	STS  __Tel,R30
	STS  __Tel+1,R31
; 0000 0483                     Otboy();                            //   ( )
	RCALL _Otboy
; 0000 0484                     if (_Tel==1)                        //  ""    
	LDS  R26,__Tel
	LDS  R27,__Tel+1
	SBIW R26,1
	BRNE _0x1A7
; 0000 0485                         {
; 0000 0486                         PORTC.3 = 1;
	SBI  0x15,3
; 0000 0487                         _flag = 1;                      //  SMS "Zvonok"
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  __flag,R30
	STS  __flag+1,R31
; 0000 0488                         Zapusk();
	RCALL _Zapusk
; 0000 0489                         _Tel = 0;
	LDI  R30,LOW(0)
	STS  __Tel,R30
	STS  __Tel+1,R30
; 0000 048A                         PORTC.3 = 0;                    // Led    Off
	CBI  0x15,3
; 0000 048B                         }
; 0000 048C                     }
_0x1A7:
; 0000 048D                 }
_0x1A6:
; 0000 048E //-------------    ----------------------------
; 0000 048F             if (PINC.0==1)                              // ----   ( ) ----
_0x1A5:
	SBIS 0x13,0
	RJMP _0x1AC
; 0000 0490                 { int i=0; int r=0;
; 0000 0491                 for (;PINC.0==1;) delay_ms (100);       //   
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	STD  Y+3,R30
;	t1 -> Y+10
;	t2 -> Y+8
;	t3 -> Y+6
;	t4 -> Y+4
;	i -> Y+2
;	r -> Y+0
_0x1AE:
	SBIS 0x13,0
	RJMP _0x1AF
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	RJMP _0x1AE
_0x1AF:
; 0000 0493 for (i=0;i<6;i++)
	LDI  R30,LOW(0)
	STD  Y+2,R30
	STD  Y+2+1,R30
_0x1B1:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,6
	BRGE _0x1B2
; 0000 0494                     {                                   //      2  (   ...
; 0000 0495                     if (r==0)
	LD   R30,Y
	LDD  R31,Y+1
	SBIW R30,0
	BRNE _0x1B3
; 0000 0496                         {
; 0000 0497                         PORTC.2 = 1;
	SBI  0x15,2
; 0000 0498                         r=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   Y,R30
	STD  Y+1,R31
; 0000 0499                         }
; 0000 049A                     else
	RJMP _0x1B6
_0x1B3:
; 0000 049B                         {
; 0000 049C                         PORTC.2 = 0;
	CBI  0x15,2
; 0000 049D                         r=0;
	LDI  R30,LOW(0)
	STD  Y+0,R30
	STD  Y+0+1,R30
; 0000 049E                         };
_0x1B6:
; 0000 049F                     delay_ms (330);
	LDI  R26,LOW(330)
	LDI  R27,HIGH(330)
	RCALL _delay_ms
; 0000 04A0                     };
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	RJMP _0x1B1
_0x1B2:
; 0000 04A1                 for (i=0;i<20;i++)                      //  3     
	LDI  R30,LOW(0)
	STD  Y+2,R30
	STD  Y+2+1,R30
_0x1BA:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,20
	BRGE _0x1BB
; 0000 04A2                     {
; 0000 04A3                     #asm("wdr");                        //   
	wdr
; 0000 04A4                     if (r==0)
	LD   R30,Y
	LDD  R31,Y+1
	SBIW R30,0
	BRNE _0x1BC
; 0000 04A5                         {
; 0000 04A6                         PORTC.2 = 1;
	SBI  0x15,2
; 0000 04A7                         r=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   Y,R30
	STD  Y+1,R31
; 0000 04A8                         }
; 0000 04A9                     else
	RJMP _0x1BF
_0x1BC:
; 0000 04AA                         {
; 0000 04AB                         PORTC.2 = 0;
	CBI  0x15,2
; 0000 04AC                         r=0;
	LDI  R30,LOW(0)
	STD  Y+0,R30
	STD  Y+0+1,R30
; 0000 04AD                         };
_0x1BF:
; 0000 04AE                     delay_ms (150);
	LDI  R26,LOW(150)
	LDI  R27,0
	RCALL _delay_ms
; 0000 04AF                     if (PINC.0==1)                      //        3    ...
	SBIS 0x13,0
	RJMP _0x1C2
; 0000 04B0                         {
; 0000 04B1                         _flag = 2;                      //  SMS "Brelok"
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	STS  __flag,R30
	STS  __flag+1,R31
; 0000 04B2                         for (;PINC.0==1;) delay_ms (100);   //   
_0x1C4:
	SBIS 0x13,0
	RJMP _0x1C5
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	RJMP _0x1C4
_0x1C5:
; 0000 04B3 PORTC.2 = 1;
	SBI  0x15,2
; 0000 04B4                         _Err = 0;                       //  
	LDI  R30,LOW(0)
	STS  __Err,R30
	STS  __Err+1,R30
; 0000 04B5                         i=31;                           //   
	LDI  R30,LOW(31)
	LDI  R31,HIGH(31)
	STD  Y+2,R30
	STD  Y+2+1,R31
; 0000 04B6                         _Blokir=0;
	LDI  R30,LOW(0)
	STS  __Blokir,R30
	STS  __Blokir+1,R30
; 0000 04B7                         Zapusk();
	RCALL _Zapusk
; 0000 04B8                         PORTC.2 = 0;
	CBI  0x15,2
; 0000 04B9                         };
_0x1C2:
; 0000 04BA                     };
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	RJMP _0x1BA
_0x1BB:
; 0000 04BB                 };
	ADIW R28,4
_0x1AC:
; 0000 04BC             };
_0x196:
; 0000 04BD 
; 0000 04BE         };
_0x182:
; 0000 04BF 
; 0000 04C0     };
	ADIW R28,8
	RJMP _0x163
; 0000 04C1 }
_0x1CA:
	RJMP _0x1CA
; .FEND

	.CSEG
_ds18b20_select:
; .FSTART _ds18b20_select
	RCALL SUBOPT_0xD
	ST   -Y,R17
	RCALL _w1_init
	CPI  R30,0
	BRNE _0x2000003
	LDI  R30,LOW(0)
	RJMP _0x2020002
_0x2000003:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	SBIW R30,0
	BREQ _0x2000004
	LDI  R26,LOW(85)
	RCALL _w1_write
	LDI  R17,LOW(0)
_0x2000006:
	RCALL SUBOPT_0x52
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R26,R30
	RCALL _w1_write
	SUBI R17,-LOW(1)
	CPI  R17,8
	BRLO _0x2000006
	RJMP _0x2000008
_0x2000004:
	LDI  R26,LOW(204)
	RCALL _w1_write
_0x2000008:
	LDI  R30,LOW(1)
	RJMP _0x2020002
; .FEND
_ds18b20_read_spd:
; .FSTART _ds18b20_read_spd
	RCALL SUBOPT_0xD
	RCALL __SAVELOCR4
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL SUBOPT_0x53
	BRNE _0x2000009
	LDI  R30,LOW(0)
	RJMP _0x2020003
_0x2000009:
	LDI  R26,LOW(190)
	RCALL _w1_write
	LDI  R17,LOW(0)
	__POINTWRM 18,19,___ds18b20_scratch_pad
_0x200000B:
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	RCALL _w1_read
	POP  R26
	POP  R27
	ST   X,R30
	SUBI R17,-LOW(1)
	CPI  R17,9
	BRLO _0x200000B
	LDI  R30,LOW(___ds18b20_scratch_pad)
	LDI  R31,HIGH(___ds18b20_scratch_pad)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(9)
	RCALL _w1_dow_crc8
	RCALL __LNEGB1
_0x2020003:
	RCALL __LOADLOCR4
_0x2020004:
	ADIW R28,6
	RET
; .FEND
_ds18b20_temperature:
; .FSTART _ds18b20_temperature
	RCALL SUBOPT_0xD
	ST   -Y,R17
	RCALL SUBOPT_0x52
	RCALL _ds18b20_read_spd
	CPI  R30,0
	BRNE _0x200000D
	RCALL SUBOPT_0x54
	RJMP _0x2020002
_0x200000D:
	__GETB1MN ___ds18b20_scratch_pad,4
	SWAP R30
	ANDI R30,0xF
	LSR  R30
	ANDI R30,LOW(0x3)
	MOV  R17,R30
	RCALL SUBOPT_0x52
	RCALL SUBOPT_0x53
	BRNE _0x200000E
	RCALL SUBOPT_0x54
	RJMP _0x2020002
_0x200000E:
	LDI  R26,LOW(68)
	RCALL _w1_write
	MOV  R30,R17
	LDI  R26,LOW(_conv_delay_G100*2)
	LDI  R27,HIGH(_conv_delay_G100*2)
	RCALL SUBOPT_0x55
	RCALL __GETW2PF
	RCALL _delay_ms
	RCALL SUBOPT_0x52
	RCALL _ds18b20_read_spd
	CPI  R30,0
	BRNE _0x200000F
	RCALL SUBOPT_0x54
	RJMP _0x2020002
_0x200000F:
	RCALL _w1_init
	MOV  R30,R17
	LDI  R26,LOW(_bit_mask_G100*2)
	LDI  R27,HIGH(_bit_mask_G100*2)
	RCALL SUBOPT_0x55
	RCALL __GETW1PF
	LDS  R26,___ds18b20_scratch_pad
	LDS  R27,___ds18b20_scratch_pad+1
	AND  R30,R26
	AND  R31,R27
	RCALL __CWD1
	RCALL __CDF1
	__GETD2N 0x3D800000
	RCALL __MULF12
_0x2020002:
	LDD  R17,Y+0
	ADIW R28,3
	RET
; .FEND
_ds18b20_init:
; .FSTART _ds18b20_init
	ST   -Y,R26
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	RCALL SUBOPT_0x53
	BRNE _0x2000010
	LDI  R30,LOW(0)
	RJMP _0x2020001
_0x2000010:
	LD   R30,Y
	SWAP R30
	ANDI R30,0xF0
	LSL  R30
	ORI  R30,LOW(0x1F)
	ST   Y,R30
	LDI  R26,LOW(78)
	RCALL _w1_write
	LDD  R26,Y+1
	RCALL _w1_write
	LDD  R26,Y+2
	RCALL _w1_write
	LD   R26,Y
	RCALL _w1_write
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	RCALL _ds18b20_read_spd
	CPI  R30,0
	BRNE _0x2000011
	LDI  R30,LOW(0)
	RJMP _0x2020001
_0x2000011:
	__GETB2MN ___ds18b20_scratch_pad,3
	LDD  R30,Y+2
	CP   R30,R26
	BRNE _0x2000013
	__GETB2MN ___ds18b20_scratch_pad,2
	LDD  R30,Y+1
	CP   R30,R26
	BRNE _0x2000013
	__GETB2MN ___ds18b20_scratch_pad,4
	LD   R30,Y
	CP   R30,R26
	BREQ _0x2000012
_0x2000013:
	LDI  R30,LOW(0)
	RJMP _0x2020001
_0x2000012:
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	RCALL SUBOPT_0x53
	BRNE _0x2000015
	LDI  R30,LOW(0)
	RJMP _0x2020001
_0x2000015:
	LDI  R26,LOW(72)
	RCALL _w1_write
	LDI  R26,LOW(15)
	RCALL SUBOPT_0x42
	RCALL _w1_init
_0x2020001:
	ADIW R28,5
	RET
; .FEND

	.DSEG
___ds18b20_scratch_pad:
	.BYTE 0x9
_temp1:
	.BYTE 0x4
_rom_code:
	.BYTE 0x12
_Bt:
	.BYTE 0x1
_Ct:
	.BYTE 0x1
_Dt:
	.BYTE 0x1
_znak:
	.BYTE 0x2
_Bt1:
	.BYTE 0x2
_i:
	.BYTE 0x1
_rx_cursor:
	.BYTE 0x1
_MyBuffer:
	.BYTE 0x96
_z:
	.BYTE 0x2
_cmd_8:
	.BYTE 0xD
__flag:
	.BYTE 0x2
_Temperat:
	.BYTE 0x2
__Err:
	.BYTE 0x2
__Err_out:
	.BYTE 0x2
__Blokir:
	.BYTE 0x2
__Tel:
	.BYTE 0x2
_Ring:
	.BYTE 0x2
_Deact:
	.BYTE 0x2
__Tel_SMS:
	.BYTE 0x1
__tim:
	.BYTE 0x2
_SMS_dlinna:
	.BYTE 0x1
_SMS_zag:
	.BYTE 0x1C
_SMS_text:
	.BYTE 0x118

	.ESEG
_cmd_8e:
	.BYTE 0x1
__Tel_SMS_E:
	.DB  0x0

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x0:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 32 TIMES, CODE SIZE REDUCTION:122 WORDS
SUBOPT_0x1:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x3:
	LDS  R26,_Ring
	LDS  R27,_Ring+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 22 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5:
	LDI  R26,LOW(_Ring)
	LDI  R27,HIGH(_Ring)
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x6:
	LDI  R30,LOW(0)
	STS  _Ring,R30
	STS  _Ring+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x7:
	LDS  R26,_Deact
	LDS  R27,_Deact+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x8:
	LDI  R26,LOW(_Deact)
	LDI  R27,HIGH(_Deact)
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(0)
	STS  _Deact,R30
	STS  _Deact+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xA:
	LDI  R31,0
	SUBI R30,LOW(-_MyBuffer)
	SBCI R31,HIGH(-_MyBuffer)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	STS  _i,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xC:
	RCALL SUBOPT_0x4
	STS  _Temperat,R30
	STS  _Temperat+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xD:
	ST   -Y,R27
	ST   -Y,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x10:
	LDS  R26,_znak
	LDS  R27,_znak+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x12:
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x13:
	STS  _temp1,R30
	STS  _temp1+1,R31
	STS  _temp1+2,R22
	STS  _temp1+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x14:
	LDS  R26,_temp1
	LDS  R27,_temp1+1
	LDS  R24,_temp1+2
	LDS  R25,_temp1+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x15:
	LDS  R30,_temp1
	LDS  R31,_temp1+1
	LDS  R22,_temp1+2
	LDS  R23,_temp1+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x16:
	LDI  R30,LOW(0)
	STS  _rx_cursor,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x17:
	LDI  R26,LOW(1000)
	LDI  R27,HIGH(1000)
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x18:
	SUBI R30,LOW(-_cmd_8)
	SBCI R31,HIGH(-_cmd_8)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x19:
	LDS  R30,_rx_cursor
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1A:
	RCALL SUBOPT_0x19
	SUBI R30,-LOW(1)
	STS  _rx_cursor,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:78 WORDS
SUBOPT_0x1B:
	LDI  R30,LOW(0)
	STS  _z,R30
	STS  _z+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1C:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_4*2)
	SBCI R31,HIGH(-_cmd_4*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x1D:
	LPM  R30,Z
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x1E:
	LPM  R0,Z
	OUT  0xC,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x1F:
	LDI  R26,LOW(100)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 23 TIMES, CODE SIZE REDUCTION:42 WORDS
SUBOPT_0x20:
	LDI  R26,LOW(_z)
	LDI  R27,HIGH(_z)
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x21:
	LDI  R30,LOW(13)
	OUT  0xC,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x22:
	LDI  R26,LOW(1500)
	LDI  R27,HIGH(1500)
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x23:
	__GETWRN 16,17,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x24:
	__ADDWRN 16,17,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x25:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_1*2)
	SBCI R31,HIGH(-_cmd_1*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:34 WORDS
SUBOPT_0x26:
	LDI  R26,LOW(50)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x27:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_0*2)
	SBCI R31,HIGH(-_cmd_0*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x28:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_9*2)
	SBCI R31,HIGH(-_cmd_9*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x29:
	MOV  R16,R30
	MOV  R17,R30
	ANDI R16,LOW(15)
	CPI  R16,10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2A:
	ANDI R17,LOW(240)
	SWAP R17
	ANDI R17,0xF
	CPI  R17,10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2B:
	LDS  R30,_SMS_dlinna
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2C:
	LDI  R31,0
	SUBI R30,LOW(-_SMS_text)
	SBCI R31,HIGH(-_SMS_text)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x2D:
	RCALL SUBOPT_0x2B
	SUBI R30,-LOW(1)
	STS  _SMS_dlinna,R30
	RCALL SUBOPT_0x2B
	RJMP SUBOPT_0x2C

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2E:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_5*2)
	SBCI R31,HIGH(-_cmd_5*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x2F:
	LPM  R16,Z
	CLR  R17
	__CPWRN 16,17,128
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x30:
	__ADDWRN 16,17,848
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x31:
	MOVW R26,R16
	RJMP _bait_seg

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x32:
	LDS  R26,__flag
	LDS  R27,__flag+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x33:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_6*2)
	SBCI R31,HIGH(-_cmd_6*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x34:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_7*2)
	SBCI R31,HIGH(-_cmd_7*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x35:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_11*2)
	SBCI R31,HIGH(-_cmd_11*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x36:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_12*2)
	SBCI R31,HIGH(-_cmd_12*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x37:
	LDI  R27,0
	RJMP _bait_seg

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x38:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_14*2)
	SBCI R31,HIGH(-_cmd_14*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x39:
	CLR  R27
	RJMP _bait_seg

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x3A:
	LDS  R26,_z
	LDS  R27,_z+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES, CODE SIZE REDUCTION:49 WORDS
SUBOPT_0x3B:
	LDS  R30,_z
	LDS  R31,_z+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x3C:
	MOV  R30,R19
	LDI  R31,0
	SUBI R30,LOW(-_SMS_zag)
	SBCI R31,HIGH(-_SMS_zag)
	ST   Z,R17
	SUBI R19,-1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3D:
	RCALL SUBOPT_0x3B
	RJMP SUBOPT_0x18

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x3E:
	MOV  R30,R19
	LDI  R31,0
	SUBI R30,LOW(-_SMS_zag)
	SBCI R31,HIGH(-_SMS_zag)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3F:
	LDI  R26,LOW(48)
	STD  Z+0,R26
	SUBI R19,-1
	RJMP SUBOPT_0x3E

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x40:
	RCALL SUBOPT_0x3B
	SUBI R30,LOW(-_cmd_2_1*2)
	SBCI R31,HIGH(-_cmd_2_1*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x41:
	LD   R30,Z
	OUT  0xC,R30
	RJMP SUBOPT_0x26

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x42:
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x43:
	__GETWRN 16,17,3000
	RCALL SUBOPT_0x4
	STS  __Err_out,R30
	STS  __Err_out+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x44:
	RCALL SUBOPT_0x4
	STS  __Blokir,R30
	STS  __Blokir+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x45:
	LDI  R30,LOW(0)
	STS  __Err_out,R30
	STS  __Err_out+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x46:
	LDS  R26,__Err
	LDS  R27,__Err+1
	SBIW R26,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x47:
	__GETWRN 18,19,30
	RCALL SUBOPT_0x4
	STS  __Err_out,R30
	STS  __Err_out+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x48:
	LDS  R26,__Err_out
	LDS  R27,__Err_out+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x49:
	__GETWRN 16,17,-15536
	RCALL SUBOPT_0x4
	STS  __Err_out,R30
	STS  __Err_out+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4A:
	CBI  0x18,1
	CBI  0x18,0
	__GETWRN 16,17,-15536
	LDI  R30,LOW(410)
	LDI  R31,HIGH(410)
	ST   Y,R30
	STD  Y+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4B:
	LDI  R30,LOW(410)
	LDI  R31,HIGH(410)
	ST   Y,R30
	STD  Y+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x4C:
	__GETWRN 18,19,70
	RCALL SUBOPT_0x4
	STS  __Err_out,R30
	STS  __Err_out+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x4D:
	RCALL _AON_
	STS  __Tel,R30
	STS  __Tel+1,R31
	RCALL _Otboy
	LDS  R26,__Tel
	LDS  R27,__Tel+1
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4E:
	LDI  R30,LOW(0)
	STS  __Err,R30
	STS  __Err+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4F:
	LDI  R30,LOW(0)
	STS  _Temperat,R30
	STS  _Temperat+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x50:
	STS  __flag,R30
	STS  __flag+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x51:
	MOVW R0,R30
	RCALL SUBOPT_0x3A
	SUBI R26,LOW(-_cmd_8e)
	SBCI R27,HIGH(-_cmd_8e)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x52:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x53:
	RCALL _ds18b20_select
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x54:
	__GETD1N 0xC61C3C00
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x55:
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

_w1_init:
	clr  r30
	cbi  __w1_port,__w1_bit
	sbi  __w1_port-1,__w1_bit
	__DELAY_USW 0x1E0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x13
	sbis __w1_port-2,__w1_bit
	ret
	__DELAY_USB 0x65
	sbis __w1_port-2,__w1_bit
	ldi  r30,1
	__DELAY_USW 0x186
	ret

__w1_read_bit:
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x3
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0xF
	clc
	sbic __w1_port-2,__w1_bit
	sec
	ror  r30
	__DELAY_USB 0x6B
	ret

__w1_write_bit:
	clt
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x3
	sbrc r23,0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x11
	sbic __w1_port-2,__w1_bit
	rjmp __w1_write_bit0
	sbrs r23,0
	rjmp __w1_write_bit1
	ret
__w1_write_bit0:
	sbrs r23,0
	ret
__w1_write_bit1:
	__DELAY_USB 0x64
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x7
	set
	ret

_w1_read:
	ldi  r22,8
	__w1_read0:
	rcall __w1_read_bit
	dec  r22
	brne __w1_read0
	ret

_w1_write:
	mov  r23,r26
	ldi  r22,8
	clr  r30
__w1_write0:
	rcall __w1_write_bit
	brtc __w1_write1
	ror  r23
	dec  r22
	brne __w1_write0
	inc  r30
__w1_write1:
	ret

_w1_search:
	push r20
	push r21
	clr  r1
	clr  r20
__w1_search0:
	mov  r0,r1
	clr  r1
	rcall _w1_init
	tst  r30
	breq __w1_search7
	push r26
	ld   r26,y
	rcall _w1_write
	pop  r26
	ldi  r21,1
__w1_search1:
	cp   r21,r0
	brsh __w1_search6
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search2
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search3
	rcall __sel_bit
	and  r24,r25
	brne __w1_search3
	mov  r1,r21
	rjmp __w1_search3
__w1_search2:
	rcall __w1_read_bit
__w1_search3:
	rcall __sel_bit
	and  r24,r25
	ldi  r23,0
	breq __w1_search5
__w1_search4:
	ldi  r23,1
__w1_search5:
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search6:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search9
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search8
__w1_search7:
	mov  r30,r20
	pop  r21
	pop  r20
	adiw r28,1
	ret
__w1_search8:
	set
	rcall __set_bit
	rjmp __w1_search4
__w1_search9:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search10
	rjmp __w1_search11
__w1_search10:
	cp   r21,r0
	breq __w1_search12
	mov  r1,r21
__w1_search11:
	clt
	rcall __set_bit
	clr  r23
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search12:
	set
	rcall __set_bit
	ldi  r23,1
	rcall __w1_write_bit
__w1_search13:
	inc  r21
	cpi  r21,65
	brlt __w1_search1
	rcall __w1_read_bit
	rol  r30
	rol  r30
	andi r30,1
	adiw r26,8
	st   x,r30
	sbiw r26,8
	inc  r20
	tst  r1
	breq __w1_search7
	ldi  r21,9
__w1_search14:
	ld   r30,x
	adiw r26,9
	st   x,r30
	sbiw r26,8
	dec  r21
	brne __w1_search14
	rjmp __w1_search0

__sel_bit:
	mov  r30,r21
	dec  r30
	mov  r22,r30
	lsr  r30
	lsr  r30
	lsr  r30
	clr  r31
	add  r30,r26
	adc  r31,r27
	ld   r24,z
	ldi  r25,1
	andi r22,7
__sel_bit0:
	breq __sel_bit1
	lsl  r25
	dec  r22
	rjmp __sel_bit0
__sel_bit1:
	ret

__set_bit:
	rcall __sel_bit
	brts __set_bit2
	com  r25
	and  r24,r25
	rjmp __set_bit3
__set_bit2:
	or   r24,r25
__set_bit3:
	st   z,r24
	ret

_w1_dow_crc8:
	clr  r30
	tst  r26
	breq __w1_dow_crc83
	mov  r24,r26
	ldi  r22,0x18
	ld   r26,y
	ldd  r27,y+1
__w1_dow_crc80:
	ldi  r25,8
	ld   r31,x+
__w1_dow_crc81:
	mov  r23,r31
	eor  r23,r30
	ror  r23
	brcc __w1_dow_crc82
	eor  r30,r22
__w1_dow_crc82:
	ror  r30
	lsr  r31
	dec  r25
	brne __w1_dow_crc81
	dec  r24
	brne __w1_dow_crc80
__w1_dow_crc83:
	adiw r28,2
	ret

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__LTF12:
	RCALL __CMPF12
	LDI  R30,1
	BREQ __LTF120
	BRCS __LTF121
__LTF120:
	CLR  R30
__LTF121:
	RET

__GTF12:
	RCALL __CMPF12
	LDI  R30,1
	BREQ __GTF120
	BRCC __GTF121
__GTF120:
	CLR  R30
__GTF121:
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__GETW2PF:
	LPM  R26,Z+
	LPM  R27,Z
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
